unit DebugView;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Mask, ComCtrls;

type
  TDebugFrm = class(TForm)
    DbgList: TListBox;
    TopPnl: TPanel;
    StartBtn: TButton;
    ChbEdit: TMaskEdit;
    ChbLbl: TLabel;
    ResultBar: TStatusBar;
    OpzioniBox: TGroupBox;
    MinimaxRadio: TRadioButton;
    AlfaBetaRadio: TRadioButton;
    DepthEdt: TLabeledEdit;
    TimeChk: TCheckBox;
    DbgLevelRadio: TRadioGroup;
    procedure FormShow(Sender: TObject);
    procedure ChbEditKeyPress(Sender: TObject; var Key: Char);
    procedure StartBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DebugFrm: TDebugFrm;

implementation

uses Main, MvList, InternalEngine, DebugU;

{$R *.dfm}

procedure TDebugFrm.FormShow(Sender: TObject);
begin
//  MainFrm.Top := Screen.WorkAreaHeight - (MainFrm.Height + Height);
  MainFrm.Top := 0;
  MainFrm.Left := 0;
  Top := 0;
  Left := MainFrm.Left + MainFrm.Width;
//  Top := MainFrm.Top + MainFrm.Height;
//  Left := MainFrm.Left;
  MvListFrm.Top := MainFrm.Top;
  MvListFrm.Left := MainFrm.Left + MainFrm.Width + Width;
end;

procedure TDebugFrm.ChbEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    StartBtnClick(Sender);
    Key := #0
  end
  else if (Key <> 'O') and (Key <> 'X') and (Key <> ' ') then
  begin
    Beep;
    Key := #0
  end
end;

procedure TDebugFrm.StartBtnClick(Sender: TObject);
var
  DbgLevel: TDebugLevel;
  mossa,valore: integer;
  tempo: string;
  Save_Cursor:TCursor;
  {  la DDETopic ricopiata }
  function BuildAlgoString: string;
  begin
    if MinimaxRadio.Checked then
      result := 'minimax'
    else result := 'alfabeta';
    result := result + ',' + IntToStr(StrToInt(DepthEdt.Text));
    if TimeChk.Checked then
      result := result + ',T';
  end;
begin
  DbgLevel := TDebugLevel(DbgLevelRadio.ItemIndex);
  DbgList.Clear;
  ResultBar.SimpleText := 'Elaboro...';
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;    { Show hourglass cursor }
  try
    { Do some lengthy operation }
    MossaComputer(BuildAlgoString,ChbEdit.Text,mossa,valore,tempo,
                  DbgLevel,DbgList.Items);
  finally
    Screen.Cursor := Save_Cursor;  { Always restore to normal }
  end;
  ResultBar.SimpleText :=
    'mossa: ' + IntToStr(mossa) + '; ' +
    'valore: ' + IntToStr(valore) + '; ' +
    'tempo: ' + tempo
end;

procedure TDebugFrm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ssCtrl in Shift then
  begin
    { copia la partita in corso nella stringa di debug }
    if Key = VK_F11 then
    begin
      ChbEdit.Text := MainFrm.Board;
      Key := 0
    end
  end
end;

end.
