unit InternalEngine;

interface

uses SysUtils,Classes,Math,DebugU;

procedure MossaComputer(Algorithm: string; Board: string;
  var Mossa,Valore: integer; var Tempo: string;
  DbgLevel: TDebugLevel = dlNone; StrList: TStrings = nil);

implementation

uses AlfaBetaU, RegoleU, ParseStringU;

procedure MossaComputer(Algorithm: string; Board: string;
  var Mossa,Valore: integer; var Tempo: string;
  DbgLevel: TDebugLevel = dlNone; StrList: TStrings = nil);
var
  Ply: integer;
  Iniz,Finale: TDateTime;
  num,Depth: integer;
  params: array[1..3] of string;
  Position: TPosition;
  Algo: TAlgorithm;
  Debug: TDebug;
  MossaStr: string;
begin
  num := ParseString(Algorithm,',',params);
  if params[1] = 'minimax' then
    Algo := alMinimax
  else if params[1] = 'alfabeta' then
    Algo := alAlfabeta
  else
    raise Exception.Create('Algoritmo sconosciuto');
  Depth := StrToInt(params[2]);
  // il parametro 3 NON  ignorato: vedi dopo
//  BestMove := nil; Debug := nil; // trucco cos posso usare un solo try
  Position := TPosition.Create;
  if assigned(StrList) then
    Debug := TDebug.Create(DbgLevel,StrList)
  else
    Debug := TDebug.CreateFile(DbgLevel,'debug.txt');
  try
    Position.SetChessboard(Board);
    Ply := 9 - Position.RemainingMoves;
    Depth := min(Depth,9-Ply);
    Iniz := Time;
    ChooseMove(Algo,Debug,Depth,Position,MossaStr,Valore);
    Finale := Time;
    Mossa := StrToInt(MossaStr);
    { se l'utente non ha richiesto i tempi viene ritornato Tempo = '' }
    if num >= 3 then Tempo := IntToStr(Trunc((Finale-Iniz)*24*3600*1000))
    else Tempo := '';
  finally
    Debug.Free;
    Position.Free
  end
end;

end.
