unit DbgMosseU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TDbgMosseFrm = class(TForm)
    PrologPnl: TGroupBox;
    PrologBiancheList: TListBox;
    PrologNereList: TListBox;
    DelphiPnl: TGroupBox;
    DelphiBiancheList: TListBox;
    DelphiNereList: TListBox;
    PrologCommandPnl: TPanel;
    PrologImportBtn: TButton;
    DelphiCommandPnl: TPanel;
    DelphiImportBtn: TButton;
    procedure PrologImportBtnClick(Sender: TObject);
    procedure DelphiImportBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DbgMosseFrm: TDbgMosseFrm;

implementation

uses DebugView, ModuloDati, Game, Main;

{$R *.dfm}

function ExtractFileBase(fullname: string): string;
var
  i: integer;
  found: integer;
begin
  result := ExtractFileName(fullname);
  found := 0;
  for i := Length(result) downto 1 do
    if result[i] = '.' then
    begin
      found := i;
      break
    end;
  if found > 0 then result := Copy(result,1,found-1)
end;

function Converti(path: string): string;
var
  i: integer;
begin
  result := '';
  for i := 1 to Length(path) do
    if path[i] = '\' then result := result + '/'
    else result := result + path[i]
end;

procedure LeggiDaFile(Filename: string; var Bianche,Nere: string);
var
  TextF: TextFile;
  mossebianche,mossenere: string[255];
begin
  AssignFile(TextF,Filename);
  FileMode := 0;  {Set file access to read only }
  Reset(TextF);
  readln(TextF,mossebianche);
  readln(TextF,mossenere);
  CloseFile(TextF);
  Bianche := MosseBianche;
  Nere := MosseNere
end;

procedure TDbgMosseFrm.PrologImportBtnClick(Sender: TObject);
const
  formatString = 'test -- "<%s" "#>%s"';
  PrologDir = 'D:\Documenti\Fabrizio\Progetti\Prolog\Progetto\Scacchi\';
  MosseDir = PrologDir + 'Mosse\';
  EserciziDir = PrologDir + 'Esercizi\';
var
  CommandLine: string;
  Filename1,MosseFN: string;
  MosseFilename: string;
  MosseBianche,MosseNere: string;
begin
  Filename1 := EserciziDir + ExtractFileBase(NomeFile) + '.txt';
//  ShowMessage('salvo su ' + Filename1);
  SaveToTextFile(Filename1);
  MosseFilename := MosseDir + ExtractFileBase(NomeFile) + '_mosse.txt';
  Filename1 := Converti(Filename1);
  MosseFN := Converti(MosseFilename);
  CommandLine := format(FormatString,[Filename1,MosseFN]);
//  ShowMessage(CommandLine);
  WinExec(PChar(CommandLine),SW_NORMAL);
  Sleep(1000); // altrimenti non funziona
  LeggiDaFile(MosseFilename,MosseBianche,MosseNere);
  PrologBiancheList.Items.CommaText := MosseBianche;
  PrologNereList.Items.CommaText := MosseNere
end;

procedure TDbgMosseFrm.DelphiImportBtnClick(Sender: TObject);
begin
  with DebugFrm do GeneraMosse('bianco',ChbEdit.Text,DelphiBiancheList);
  with DebugFrm do GeneraMosse('nero',ChbEdit.Text,DelphiNereList);
end;

procedure TDbgMosseFrm.FormResize(Sender: TObject);
var
  w,h: integer;
begin
  w := (PrologPnl.Width - 81) div 2;
  PrologBiancheList.Width := w;
  PrologNereList.Width := w;
  DelphiBiancheList.Width := w;
  DelphiNereList.Width := w;

  h := ClientHeight div 2;
  PrologPnl.Height := h;
  DelphiPnl.Height := h
end;

procedure TDbgMosseFrm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if MainFrm.AmministraTastiDebug(Key,Shift) then Key := 0
end;

end.
