unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, ComCtrls, TeEngine, Series,
  TeeProcs, Chart, Mask, Math, Buttons, ImgList, ToolWin,
  Menus, DdeMan, Game, Setup, Types, ParseStringU;

type
  TStatus = (stNormal,stWaitingSolution);
  TMainFrm = class(TForm)
    MainToolbar: TToolBar;
    OpenBtn: TToolButton;
    SaveBtn: TToolButton;
    AboutBtn: TToolButton;
    Sep1: TToolButton;
    RightPnl: TPanel;
    MainPanel: TPanel;
    WhitePiecesPnl: TPanel;
    BlackPiecesPnl: TPanel;
    ImportGfxBtn: TToolButton;
    ExportGfxBtn: TToolButton;
    sep2: TToolButton;
    BlackPiecesImg: TImage;
    WhitePiecesImg: TImage;
    SetupBtn: TToolButton;
    ChessboardPnl: TPanel;
    ChessBoardImg: TImage;
    ZoomRadio: TRadioGroup;
    FindSolutionBtn: TButton;
    SolDetailsBox: TGroupBox;
    SolutionLbl: TStaticText;
    SolDetailsList: TListBox;
    Sep3: TToolButton;
    StatusBar1: TStatusBar;
    ToolButton1: TToolButton;
    HeaderPnl: TPanel;
    NumEdt: TLabeledEdit;
    AuthorEdt: TLabeledEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Strumenti1: TMenuItem;
    Impostazionigrafiche1: TMenuItem;
    N3: TMenuItem;
    Caricadatesto1: TMenuItem;
    Salvasutesto1: TMenuItem;
    ToolButton2: TToolButton;
    EngineBtn: TToolButton;
    Impostamotore1: TMenuItem;
    ToolButton3: TToolButton;
    NoMoveBtn: TSpeedButton;
    Move1Btn: TSpeedButton;
    Move2Btn: TSpeedButton;
    DelphiTopic: TDdeServerConv;
    Move3Btn: TSpeedButton;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BlackPiecesImgMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure BlackPiecesImgMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SolDetailsListDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure SolDetailsListDblClick(Sender: TObject);
    procedure SolDetailsListKeyPress(Sender: TObject; var Key: Char);
    procedure ChessBoardImgDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure ChessBoardImgDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TrackStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure DiscardPiecesDragDrop(Sender, Source: TObject; X,
      Y: Integer);
    procedure DiscardPiecesDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure NextCtrlKeyPress(Sender: TObject; var Key: Char);
    procedure NumEdtKeyPress(Sender: TObject; var Key: Char);
    procedure FindSolutionBtnClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SolutionLblDblClick(Sender: TObject);
    procedure DelphiTopicExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure NoMoveBtnClick(Sender: TObject);
    procedure Move1BtnClick(Sender: TObject);
    procedure Move2BtnClick(Sender: TObject);
    procedure Move3BtnClick(Sender: TObject);
    procedure SolDetailsListClick(Sender: TObject);
  private
    { Private declarations }
    Status: TStatus;
    Soluzione: string;
    DettagliSol: TStringArray;
    CodErrore,Mossa,Tempo: string;
    BackupPieces: TPieces;
    ChbLeft,ChbTop: integer;
    ChbWidth,ChbHeight: integer;
    TextureBmp,ChessboardBmp: TBitmap;
    PiecesBmp: array[TPlayer,TPieceType] of TBitmap;
    DragSourceX: integer;
    DragSourceY: integer;
    DragSource: TImage;
    procedure DisegnaPezzo(campo: TPlayer; n: TPiece);
    function getPieceFromMouse(campo: TPlayer; X, Y: integer): TPiece;
    function getChbPosFromMouse(X, Y: integer): TChbPosition;
    procedure InviaRichiesta(ClientConv: TDDEClientConv;
      Service,Topic,Item: string);
    function CercaSoluzione:  boolean;
    procedure ParseDetails(Params: TStringDynArray; List: TStrings);
    function TrasformaMossa(Src: string): string;
    procedure VaiAStato(newstatus: TStatus);
    procedure BackupTastiera(flag: boolean);
    procedure TrovaMosse(idx: integer; var m2, m3: string);
  public
    { Public declarations }
    Gfx: TGfxSet;
    procedure CaricaGrafica;
    procedure AggiornaGrafica;
    function AmministraTastiDebug(Key: Word; Shift: TShiftState): boolean;
    procedure ProcessaRisposta(value: string);
    procedure PulisciMossa;
  end;

var
  MainFrm: TMainFrm;

implementation

uses ModuloDati, InternalEngine, DebugView, DbgMosseU, ShowSolU;

{$R *.DFM}

procedure TMainFrm.VaiAStato(newstatus: TStatus);
begin
(*
  case newstatus of
  stNormal:
  stWaitingSolution:
  begin
  end;
  else raise Exception.Create('stato sconosciuto');
  end;
*)
  Status := NewStatus;
end;

function TMainFrm.CercaSoluzione: boolean;
var
  Save_Cursor:TCursor;
begin
  Save_Cursor := Screen.Cursor;
  Screen.Cursor := crHourGlass;    { Show hourglass cursor }
  try
    { Do some lengthy operation }
    VaiAStato(stWaitingSolution);
    result := false;

    { prima parte: connessione al motore }
    if SetupFrm.LinkType = ltDDE then
    begin
      with SetupFrm do
      begin
        { Do some lengthy operation }
        if Connetti(true) then
        try
          self.Cursor := crHourGlass;
          InviaRichiesta(DDEClientConv1,DDEService,DDETopic,BoardString);
          result := ShowSolFrm.MostraAttesa;
          VaiAStato(stNormal);
        finally
          DDEClientConv1.CloseLink;
        end
        else raise Exception.Create('Connessione al server fallita');
      end
    end
    else
    begin
      Soluzione := Matto2Mosse(SetupFrm.DDETopic,BoardString);
      VaiAStato(stNormal);
      result := true
    end;
  finally
    Screen.Cursor := Save_Cursor;  { Always restore to normal }
  end;
end;

procedure TMainFrm.ProcessaRisposta(value: string);
var
  params: TStringArray;
  num: integer;
  M: string;
begin
//  params := nil; // serve per eliminare un warning idiota

  { seconda parte: interpretazione del risultato }
  params := ParseString(value,',');
  try
    num := Length(params);
    CodErrore := params[0];
    if num >= 2 then Mossa := params[1] else Mossa := '';
    if num >= 3 then Tempo := params[2] else Tempo := '';
    if num > 3 then
    begin
      DettagliSol := Copy(params,3,num-3);
      params := nil;
      ParseDetails(DettagliSol,SolDetailsList.Items);
    end
    else DettagliSol := nil;
    if CodErrore =  'ok' then
    begin
      if Tempo <> '' then
        ShowSolFrm.MostraSoluzione('Mossa: '+TrasformaMossa(Mossa)+#13#10+
                                   'Tempo: '+Tempo+' millisecondi')
      else
        ShowSolFrm.MostraSoluzione('Mossa: '+TrasformaMossa(Mossa));
      SolutionLbl.Caption := TrasformaMossa(Mossa);
      if assigned(DettagliSol) then
      begin
        BackupTastiera(true);
        SolDetailsList.ItemIndex := 0;
        Move2Btn.Enabled := true;
        Move3Btn.Enabled := true;
      end
      else
      begin
        SolDetailsList.Clear;
        Move2Btn.Enabled := false;
        Move3Btn.Enabled := false;
      end;
      FaiMossa(cplWhite,Mossa);
      AggiornaGrafica;
      Move1Btn.Down := true;
      Move1Btn.Enabled := true;
    end
    else
    begin
      M := Mossa;
      PulisciMossa;
      if M = '' then
        ShowSolFrm.MostraSoluzione('Errore: '+ CodErrore)
      else
        ShowSolFrm.MostraSoluzione('Errore: '+ CodErrore + ' (' +
                                   TrasformaMossa(M) + ')')
    end
  finally
    params := nil
  end;

(*
  if result then
  begin
    MvListFrm.AggiungiRiga(Ply+1,'C',(Ply mod 2)+1,
                           mossa+1,valore,tempo + ' millisec.');
    cellY := mossa div 3;
    cellX := mossa mod 3;
  end
*)
(*
        cod := TCodice(rslt[1]);
        case cod of
        codVuoto: raise Exception.Create('ricevuta stringa nulla');
        codErrore: ShowMessage('Errore ritornato dal motore');
        codNoSoluz: ShowMessage('Non esiste soluzione');
//        codMattoNero
        codMatto1:
          ShowMessage('Matto in 1 mossa: ' + IntToStr(ord(rslt[2])) +
                       '= ' + IntToStr(ord(rslt[3])));
        codOk:
          ShowMessage('Soluzione: ' + IntToStr(ord(rslt[2])) +
                       '= ' + IntToStr(ord(rslt[3])));
        codNoSupporto:
          ShowMessage('Il motore non supporta questi parametri');
        else raise Exception.Create('Errore sconosciuto');
        end;

        if IncludeTime and(cod >= codNoSoluz) and (cod <= codOk) then
          SolutionLbl.Caption :=
           'Tempi: ' + Copy(rslt,4,3) + ':' + Copy(rslt,7,3);
*)
end;

function TMainFrm.TrasformaMossa(Src: string): string;
  function cambia_x(chX: char): char;
  var X: integer;
  begin
    X := ord(chX) - ord('0');
    result := char(X + ord('a') - 1)
  end;
var
  Cnt: integer;
begin
  if src = 'nil' then result := '(nessuna mossa)'
  else if src = 'o-o' then result := ' o-o     '
  else if src = 'o-o-o' then result := ' o-o-o   '
  else if Length(src) >= 5 then
  begin
    Cnt := 1;
    if Src[Cnt] = '!' then
    begin
      result := '!';
      Inc(Cnt);
    end
    else result := ' ';
    result := result + Src[Cnt] + ' ' +
              cambia_x(Src[Cnt+1]) + Src[Cnt+2] + '-' +
              cambia_x(Src[Cnt+3]) + Src[Cnt+4];
    Inc(Cnt,5);
    if Length(src) >= Cnt then result := result + 'x'
    else result := result + ' '
  end
  else result := 'errore nella mossa'
end;

procedure TMainFrm.ParseDetails(Params: TStringArray; List: TStrings);
var
  i: integer;
begin
  List.Clear;
  i := Low(Params);
  while i <= (High(Params)-1) do
  begin
    List.Add(TrasformaMossa(Params[i]) + ',' + TrasformaMossa(Params[i+1])+'#');
    Inc(i,2)
  end
end;

procedure TMainFrm.InviaRichiesta(ClientConv: TDDEClientConv;
      Service,Topic,Item: string);
begin
  { Attenzione! se il server non  aperto o non  nella stessa
    cartella fallisce }
  if ClientConv.SetLink(Service,Topic) then
    try
      if not ClientConv.ExecuteMacro(PChar(Item),false) then
        raise Exception.Create('Errore nella trasmissione dei dati');
    finally
      ClientConv.CloseLink;
    end
  else raise Exception.Create('Connessione al motore fallita');
end;

// GRAFICA
// -------

procedure TMainFrm.CaricaGrafica;
var
  AllPiecesBmp: TBitmap;
  SrcRect,DstRect: TRect;
  pl: TPlayer;
  n: TPieceType;
  FullGfxDir: string;
begin
  if Gfx.Loaded then
    with Gfx do
    begin
      FullGfxDir := ExtractFilePath(Application.ExeName) + GfxDir + '\';
      { Pezzi }
      if PiecesFilename <> '' then
      begin
        BlackPiecesPnl.Constraints.MinWidth :=
         min(320,PiecesW*8+BlackPiecesPnl.BorderWidth*2+8);
        WhitePiecesPnl.Constraints.MinWidth :=
         min(320,PiecesW*8+WhitePiecesPnl.BorderWidth*2+8);

        AllPiecesBmp := TBitmap.Create;
        try
          AllPiecesBmp.LoadFromFile(FullGfxDir+PiecesFileName);
          DstRect := Rect(0,0,PiecesW,PiecesH);
          for pl := Low(TPlayer) to High(TPlayer) do
            for n := Low(PiecesBmp[pl]) to High(PiecesBmp[pl]) do
            begin
              PiecesBmp[pl,n].Width := PiecesW;
              PiecesBmp[pl,n].Height := PiecesH;
              PiecesBmp[pl,n].Transparent := True;
              PiecesBmp[pl,n].TransparentColor := BackCol;

              SrcRect := Rect(PiecesLeftB+(PiecesW+PiecesHSep)*ord(n),
                              PiecesTopB,
                              PiecesLeftB+(PiecesW+PiecesHSep)*(ord(n)+1)-PiecesHSep,
                              PiecesTopB+PiecesH);
              if pl = cplWhite then
              begin
                Inc(SrcRect.Top,PiecesH+PiecesVSep);
                Inc(SrcRect.Bottom,PiecesH+PiecesVSep);
              end;

              PiecesBmp[pl,n].Canvas.CopyRect(DstRect,AllPiecesBmp.Canvas,SrcRect);
            end
        finally
          AllPiecesBmp.Free;
        end;
      end;

      { Chessboard }
      if ChessboardFilename <> '' then
      begin
        ChessboardBmp.LoadFromFile(FullGfxDir+ChessboardFilename);
        ChessboardImg.Constraints.MinWidth := min(320,ChessboardBmp.Width);
        ChessboardImg.Constraints.MinHeight := min(300,ChessboardBmp.Height);
        { devono stare qui dopo la modifica dei constraints della chessboard }
        BlackPiecesPnl.Height := PiecesH*2 + BlackPiecesPnl.BorderWidth*2 + 14;
        WhitePiecesPnl.Height := PiecesH*2 + WhitePiecesPnl.BorderWidth*2 + 14;

        Constraints.MinWidth := max(ChessboardImg.Constraints.MinWidth,
          BlackPiecesPnl.Constraints.MinWidth)+ RightPnl.Width + 16;
      end;

      { Textures }
      if TexturesFilename <> '' then
        TextureBmp.LoadFromFile(FullGfxDir+TexturesFilename);
  end
end;

procedure TMainFrm.AggiornaGrafica;
var
  pl: TPlayer;
  i: TPiece;
  SrcRect,DstRect: TRect;
begin
  if Gfx.Loaded then
  begin
    { disegna le textures }
    if assigned(TextureBmp) then
    begin
      with BlackPiecesImg do
      begin
        Canvas.Brush.Bitmap := TextureBmp;
        Canvas.FillRect(Rect(0,0,Width,Height));
        BlackPiecesImg.Canvas.Brush.Bitmap := nil;
      end;
      with WhitePiecesImg do
      begin
        Canvas.Brush.Bitmap := TextureBmp;
        Canvas.FillRect(Rect(0,0,Width,Height));
        WhitePiecesImg.Canvas.Brush.Bitmap := nil;
      end;
      with ChessboardImg do
      begin
        Canvas.Brush.Bitmap := TextureBmp;
        Canvas.FillRect(Rect(0,0,Width,Height));
        ChessboardImg.Canvas.Brush.Bitmap := nil;
      end;
    end;

    { disegna la scacchiera }
    if assigned(ChessboardBmp) then
    begin
      ChbWidth := ChessboardBmp.Width;
      ChbHeight := ChessboardBmp.Height;
      ChbLeft := (ChessBoardImg.Width - ChbWidth) div 2;
      ChbTop := (ChessBoardImg.Height - ChbHeight) div 2;
      SrcRect := Rect(0,0,ChbWidth,ChbHeight);
      DstRect := Rect(ChbLeft,ChbTop,ChbLeft+ChbWidth,ChbTop+ChbHeight);
      ChessboardImg.Canvas.CopyRect(DstRect,ChessboardBmp.Canvas,SrcRect);
    end;

    { disegna i pezzi }
    if assigned(PiecesBmp[cplBlack,Low(PiecesBmp[cplBlack])]) then
    begin
      for pl := Low(TPlayer) to High(TPlayer) do
        for i := Low(Pieces[pl]) to High(Pieces[pl]) do
          DisegnaPezzo(pl,i);
    end
  end
end;

procedure TMainFrm.DisegnaPezzo(campo: TPlayer; n: TPiece);
var
  DstLeft,DstTop: integer;
  Img: TImage;
  BmpIdx: TPieceType;
  Idx: integer;
begin
  BmpIdx := PieceTypes[campo,n];

  if Pieces[campo,n] = 0 then
  begin
    { disegnalo fuori dalla scacchiera }
    case campo of
    cplBlack: Img := BlackPiecesImg;
    cplWhite: Img := WhitePiecesImg
    else raise Exception.Create('????');
    end;

    if ord(n) < 8 then
    begin
      DstLeft := 4+(Gfx.PiecesW+2)*ord(n);
      DstTop := 4;
      //Right = (PiecesW+2)*(ord(n)+1), Bottom := 4+PiecesH
    end
    else
    begin
      DstLeft := 4+(Gfx.PiecesW+2)*(ord(n)-8);
      DstTop := 6+Gfx.PiecesH;
      //Right = (PiecesW+2)*(ord(n)-7), Bottom = 6+PiecesH*2;
    end;
    Img.Canvas.Draw(DstLeft,DstTop,PiecesBmp[campo,BmpIdx]);
  end
  else
  begin
    Idx := Pieces[campo,n]-1;
    { indirizzo 0,0 - in realt vanno centrate }
    DstLeft := ChbLeft + Gfx.LeftBorder + (Idx mod NumSquaresW) * Gfx.SquareW;
    DstTop := ChbTop + Gfx.TopBorder + (Idx div NumSquaresH) * Gfx.SquareH;
    ChessboardImg.Canvas.Draw(DstLeft,DstTop,PiecesBmp[campo,BmpIdx]);
  end
end;

// UTILS
// -----

function TMainFrm.getPieceFromMouse(campo: TPlayer; X,Y: integer): TPiece;
const
  offsetX = 4;
  offsetY = 4;
  separaX=2;
  separaY=2;
  tolleranzaX=1; // scelta in modo da non lasciare spazi tra i pezzi
  tolleranzaY=1; // scelta in modo da non lasciare spazi tra i pezzi
var
  lb,tb: integer; // left border, top border
begin
  with Gfx do
  begin
    lb := offsetX-tolleranzaX;
    tb := offsetY-tolleranzaY;
    { questa routine non gestisce gli spazi tra le zone sensibili }
    if (x<lb) or (x>=(PiecesW+separaX)*8) or
       (y<tb) or (y>=tb+2*(PiecesH+separaY)) then
      result := TPiece(-1)
    else
    begin
      result := TPiece((X-lb) div (PiecesW+separaX));
      if ((Y-tb) div (PiecesH+separaY)) = 1 then
        Inc(result,8);
      { se il pezzo non  a posto allora nessun pezzo }
      if Pieces[campo,result] <> 0 then result := TPiece(-1)
    end
  end
end;

function TMainFrm.getChbPosFromMouse(X,Y: integer): TChbPosition;
var
  lb,tb: integer; // REAL left border, REAL top border
begin
  lb := ChbLeft + Gfx.LeftBorder;
  tb := ChbTop + Gfx.TopBorder;
  if (x<lb) or (X>ChbLeft+ChbWidth-Gfx.LeftBorder) or
     (Y<tb) or (Y>ChbTop+ChbHeight-Gfx.TopBorder) then
    result := 0
  else
  begin
    result :=
      (((X-lb) div Gfx.SquareW) + ((Y-tb) div Gfx.SquareH) * NumSquaresW) + 1;
  end
end;

{ routine della form }
{ ------------------ }

const
  crMyCursor = 1;

procedure TMainFrm.FormCreate(Sender: TObject);
var
  pl: TPlayer;
  n: TPieceType;
begin
  Status := stNormal;
  PulisciMossa;
  for pl := Low(TPlayer) to High(TPlayer) do
    for n := Low(PiecesBmp[pl]) to High(PiecesBmp[pl]) do
      PiecesBmp[pl,n] := TBitmap.Create;
  ChessboardBmp := TBitMap.Create;
  TextureBmp := TBitmap.Create;

  Screen.Cursors[crMyCursor] := LoadCursor(HInstance, 'CURSOR1');
  Screen.Cursors[crMyCursor+1] := LoadCursor(HInstance, 'CURSORB');
  Cursor := crMyCursor
  //BlackPiecesImg.Cursor := crMyCursor;
  //WhitePiecesImg.Cursor := crMyCursor;
end;

procedure TMainFrm.BlackPiecesImgMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//  BlackPiecesImg.Cursor := crMyCursor;
//  Application.ProcessMessages;
end;

procedure TMainFrm.BlackPiecesImgMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  //BlackPiecesImg.Cursor := crHandPoint;
end;

procedure TMainFrm.FormDestroy(Sender: TObject);
var
  i: TPieceType;
  pl: TPlayer;
begin
  for pl := Low(TPlayer) to High(TPlayer) do
    for i := Low(PiecesBmp[pl]) to High(PiecesBmp[pl]) do
      if assigned(PiecesBmp[pl,i]) then PiecesBmp[pl,i].Free;
  if assigned(ChessboardBmp) then ChessboardBmp.Free;
  if assigned(TextureBmp) then TextureBmp.Free;
end;

procedure TMainFrm.FormShow(Sender: TObject);
begin
  if assigned(SetupFrm) and SetupFrm.CaricaDaRegistro then
    Gfx := SetupFrm.PreviewGfxSet;
  CaricaGrafica;
  AggiornaGrafica;
end;

procedure TMainFrm.FormResize(Sender: TObject);
begin
  if Gfx.Loaded then
  begin
    with ChessboardImg do
    begin
      Picture.Bitmap.Width := Width;
      Picture.Bitmap.Height := Height;
    end;
    with BlackPiecesImg do
    begin
      Picture.Bitmap.Width := Width;
      Picture.Bitmap.Height := Height;
    end;
    with WhitePiecesImg do
    begin
      Picture.Bitmap.Width := Width;
      Picture.Bitmap.Height := Height;
    end;
    AggiornaGrafica;
  end
end;

procedure TMainFrm.SolDetailsListDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
	Offset: Integer;      { text offset width }
  Bitmap: TBitmap;      { temporary variable for the items bitmap }
begin
	with (Control as TListBox).Canvas do  { draw on control canvas, not on the form }
	begin
    if odSelected	 in State then
    begin
      Font.Color := ClBlack;
      Font.Style := [fsBold];
    end;
    if (index mod 2) = 0 then Brush.Color := clWhite
    else Brush.Color := clMoneyGreen; //clSkyBlue;
    FillRect(Rect);       { clear the rectangle }
    Offset := 2;          { provide default offset }
    { lascio questo codice dall'esempio della guida che mi permetter
      di associare una piccola icona alle righe }
    Bitmap := TBitmap((Control as TListBox).Items.Objects[Index]);  { get the bitmap }
    if Bitmap <> nil then
    begin
        BrushCopy(Bounds(Rect.Left + Offset, Rect.Top, Bitmap.Width, Bitmap.Height),
          Bitmap, Bounds(0, 0, Bitmap.Width, Bitmap.Height), clRed);  {render bitmap}
        Offset := Bitmap.width + 6;    { add four pixels between bitmap and text}
    end;
    TextOut(Rect.Left + Offset, Rect.Top, (Control as TListBox).Items[Index])  { display the text }
  end;
end;

procedure TMainFrm.SolDetailsListDblClick(Sender: TObject);
begin
  Move3Btn.Down := true;
  Move3Btn.Click;
end;

procedure TMainFrm.SolDetailsListKeyPress(Sender: TObject; var Key: Char);
begin
  if Key =#13 then
  begin
    Move3Btn.Down := true;
    Move3Btn.Click;
  end
end;

procedure TMainFrm.ChessBoardImgDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  pezzo: TPiece;
  SrcPos,DstPos: TChbPosition;
  campo: TPlayer;
begin
  if (sender = ChessBoardImg) and assigned(DragSource) then
  begin
    if (source = BlackPiecesImg) or (source = WhitePiecesImg) then
    begin
      if source = BlackPiecesImg then campo := cplBlack
      else campo := cplWhite;

      //ChessboardImg.Canvas.Pixels[x,y] := clBlue;
      //DragSource.Canvas.Pixels[DragSourceX,DragSourceY] := clBlue;
      pezzo := getPieceFromMouse(campo,DragSourceX,DragSourceY);
      if ord(pezzo) = -1 then
        raise Exception.Create('Non hai selezionato nessun pezzo');
    end
    else
    begin
      SrcPos := getChbPosFromMouse(DragSourceX,DragSourceY);
      if (SrcPos=0) or not FindPieceAtPos(SrcPos,campo,pezzo) then
        raise Exception.Create('Hai pisciato fuori')
    end;

    DstPos := getChbPosFromMouse(X,Y);
    if (DstPos=0) or not isEmptyPos(DstPos) then
      raise Exception.Create('Hai pisciato fuori');
    Pieces[campo,pezzo] := DstPos;
    DebugFrm.ChbEdit.Text := BoardString;
    PulisciMossa;
    AggiornaGrafica;
  end
end;

procedure TMainFrm.ChessBoardImgDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  ChbPos: TChbPosition;
begin
  ChbPos := getChbPosFromMouse(X,Y);
  if (ChbPos <> 0) and isEmptyPos(ChbPos) then accept := true
  else accept := false
end;

procedure TMainFrm.TrackStartDrag(Sender: TObject;
  var DragObject: TDragObject);
var
  srcpoint: TPoint;
  campo: TPlayer;
  ChbPos: TChbPosition;
begin
  DragSource := Sender as TImage;
  srcpoint := DragSource.ScreenToClient(Mouse.CursorPos);
  DragSourceX := srcpoint.x;
  DragSourceY := srcpoint.Y;
  DragObject := nil;
  if (Sender = BlackPiecesImg) or (Sender = WhitePiecesImg) then
  begin
    if Sender = BlackPiecesImg then campo := cplBlack
    else campo := cplWhite;
    if ord(getPieceFromMouse(campo,DragSourceX,DragSourceY))= -1 then
      abort; { Uccido il trascinamento }
  end
  else
  begin
    ChbPos := getChbPosFromMouse(DragSourceX,DragSourceY);
    if (ChbPos = 0) or isEmptyPos(ChbPos) then
      abort; { Uccido il trascinamento }
  end
end;

procedure TMainFrm.DiscardPiecesDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  pl: TPlayer;
  n: TPiece;
begin
  if FindPieceAtPos(getChbPosFromMouse(DragSourceX,DragSourceY),pl,n) then
  begin
    Pieces[pl,n] := 0;
    DebugFrm.ChbEdit.Text := BoardString;
    PulisciMossa;
    AggiornaGrafica
  end
end;

procedure TMainFrm.PulisciMossa;
begin
  Mossa := ''; SolutionLbl.Caption := '';
  SolDetailsList.Clear;
  NoMoveBtn.Down := true;
  Move1Btn.Enabled := false;
  Move2Btn.Enabled := false;
  Move3Btn.Enabled := false;
end;

procedure TMainFrm.DiscardPiecesDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  pl,campo: TPlayer;
  n: TPiece;
begin
  if Sender = WhitePiecesImg then campo := cplWhite
  else campo := cplBlack;
  if (Source = ChessboardImg) and
     FindPieceAtPos(getChbPosFromMouse(DragSourceX,DragSourceY),pl,n) and
     (campo = pl) then
        accept := true
  else accept := false
end;

procedure TMainFrm.NextCtrlKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    PostMessage(Handle,WM_NEXTDLGCTL,0,0);
    Key := #0
  end
end;

procedure TMainFrm.NumEdtKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    PostMessage(Handle,WM_NEXTDLGCTL,0,0);
    Key := #0
  end
  else if (Key <> char(VK_BACK)) and ((Key < '0') or (Key > '9')) then
  begin
    Beep;
    Key := #0
  end
end;

procedure TMainFrm.FindSolutionBtnClick(Sender: TObject);
begin
  if (Mossa <> '') and (SolutionLbl.Caption <> '') then BackupTastiera(false);
  if CercaSoluzione then ProcessaRisposta(Soluzione)
end;

function TMainFrm.AmministraTastiDebug(Key: Word;
  Shift: TShiftState): boolean;
begin
  if (Shift = [ssAlt]) and (Key = VK_F12) then
  begin
    Left := 0;
    Top := 0;
    Width := Constraints.MinWidth;
    Height := Constraints.MinHeight;
    result := true
  end
  else if Shift = [ssCtrl,ssShift,ssAlt] then
  begin
    { combinazioni di tasti per il debug }
    { copia la partita in corso nella stringa di debug }
    if Key = VK_F11 then
    begin
      DebugFrm.ChbEdit.Text := BoardString;
      result := true
    end
    { apre la finestra di debug }
    else if Key = VK_F12 then
    begin
      Top := 0; Left := 0;
      DebugFrm.Top := 0;
      DebugFrm.Left := Left + Width;
      DbgMosseFrm.Left := DebugFrm.Left;
      DbgMosseFrm.Width := Screen.WorkAreaWidth - DbgMosseFrm.Left;
      DbgMosseFrm.Top := DebugFrm.Height;
      DbgMosseFrm.Height := Screen.WorkAreaHeight - DebugFrm.Height;
      DebugFrm.Show;
      DbgMosseFrm.Show;
      result := true
    end
    else result := false
  end
  else result := false
end;

procedure TMainFrm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if AmministraTastiDebug(Key,Shift) then Key := 0
end;

procedure TMainFrm.SolutionLblDblClick(Sender: TObject);
begin
//  ShowMessage(SetupFrm.DdeClientItem1.Text)
end;

procedure TMainFrm.DelphiTopicExecuteMacro(Sender: TObject; Msg: TStrings);
begin
  if status = stWaitingSolution then
  begin
    Soluzione := Msg.Text;
    VaiAStato(stNormal);
    if assigned(ShowSolFrm) and ShowSolFrm.Visible then
    begin
      ShowSolFrm.ExitBtn.Kind := bkOk;
      ShowSolFrm.ExitBtn.Click;
    end;
  end
  //else ShowMessage('Ricevuto una comunicazione inaspettata');
end;

procedure TMainFrm.NoMoveBtnClick(Sender: TObject);
begin
  if Mossa <> '' then
  begin
   BackupTastiera(false);
   AggiornaGrafica
  end
end;

procedure TMainFrm.BackupTastiera(flag: boolean);
begin
  if flag then
    BackupPieces := Pieces
  else
    Pieces := BackupPieces;
end;

procedure TMainFrm.Move1BtnClick(Sender: TObject);
begin
  if Mossa <> '' then
  begin
    BackupTastiera(false);
    FaiMossa(cplWhite,Mossa);
    AggiornaGrafica
  end
end;

procedure TMainFrm.TrovaMosse(idx: integer; var m2,m3: string);
begin
  idx := idx * 2;
  m2 := DettagliSol[idx];
  m3 := DettagliSol[idx+1]
end;

procedure TMainFrm.Move2BtnClick(Sender: TObject);
var
  Mossa2,Mossa3: string;
begin
  if (Mossa <> '') and assigned(DettagliSol) and
     (SolDetailsList.ItemIndex <> -1) then
  begin
    BackupTastiera(false);
    FaiMossa(cplWhite,Mossa);
    TrovaMosse(SolDetailsList.ItemIndex,Mossa2,Mossa3);
    FaiMossa(cplBlack,Mossa2);
    AggiornaGrafica
  end
end;

procedure TMainFrm.Move3BtnClick(Sender: TObject);
var
  Mossa2,Mossa3: string;
begin
  if (Mossa <> '') and assigned(DettagliSol) and
     (SolDetailsList.ItemIndex <> -1) then
  begin
    BackupTastiera(false);
    FaiMossa(cplWhite,Mossa);
    TrovaMosse(SolDetailsList.ItemIndex,Mossa2,Mossa3);
    FaiMossa(cplBlack,Mossa2);
    FaiMossa(cplWhite,Mossa3);
    AggiornaGrafica
  end
end;

procedure TMainFrm.SolDetailsListClick(Sender: TObject);
begin
  if Move2Btn.Down then Move2Btn.Click
  else if Move3Btn.Down then Move3Btn.Click
end;

end.
