unit ModuloDati;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ExtCtrls, ActnList, ExtDlgs, StdActns, DdeMan;

const
  ChiaveRegistro = '\Software\FB\MattoIn2Mosse\1.0';

  //BmpFilter = 'File bitmap (*.bmp)|*.bmp|Tutti i file|*.*';
  //BmpDefaultExt = 'bmp';
(*
  GfxFilter = 'File di configurazione grafica (*.cgc)|*.cgc|Tutti i file|*.*';
  GfxDefaultExt = 'cgc';
  ChbFilter = 'Scacchiere (*.chb)|*.chb|Tutti i file|*.*';
  ChbDefaultExt = 'chb';
  PiecesFilter = 'Immagini dei pezzi (*.cgp)|*.cgp|Tutti i file|*.*';
  PiecesDefaultExt = 'cgp';
  TexturesFilter = 'File di configurazione grafica (*.ctx)|*.ctx|Tutti i file|*.*';
  TexturesDefaultExt = 'ctx';
*)
  m2mFilter = 'File m2m (*.m2m)|*.m2m|Tutti i file|*.*';
  m2mDefaultExt = 'm2m';
  TxtFilter = 'File di testo (*.txt)|*.txt|Tutti i file|*.*';
  TxtDefaultExt = 'txt';

type
  TClasseDati = class(TDataModule)
    OpenDialogAll: TOpenDialog;
    SaveDialogAll: TSaveDialog;
    ActionListEditor: TActionList;
    ExitAct: TAction;
    ImageList1: TImageList;
    OpenAct: TAction;
    SaveAct: TAction;
    AboutAct: TAction;
    OpenPictureDialog1: TOpenPictureDialog;
    SavePictureDialog1: TSavePictureDialog;
    ImportAct: TAction;
    ExportAct: TAction;
    GfxSetupAct: TAction;
    NewAct: TAction;
    SaveAsAct: TAction;
    PrintAct: TAction;
    PrintSetupAct: TFilePrintSetup;
    EngineSetupAct: TAction;
    procedure ExitActExecute(Sender: TObject);
    procedure AboutActExecute(Sender: TObject);
    procedure SetupActExecute(Sender: TObject);
    procedure ExportActExecute(Sender: TObject);
    procedure NewActExecute(Sender: TObject);
    procedure OpenActExecute(Sender: TObject);
    procedure SaveAsActExecute(Sender: TObject);
    procedure FirstGfxActUpdate(Sender: TObject);
    procedure SaveActExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

function getDisposizioniDir: string;

var
  ClasseDati: TClasseDati;
  NomeFile: string = '';

implementation

uses About, Main, Setup, Game, ExportDlg, DebugView;

{$R *.DFM}

function getDisposizioniDir: string;
begin
  result := ExtractFilePath(ParamStr(0)) + 'Esercizi';
end;

{ ClasseDati }

(* carica immagine
  OpenPictureDialog1.InitialDir := getSavedir;
  OpenPictureDialog1.Filter := BmpFilter;
  OpenPictureDialog1.DefaultExt := BmpDefaultExt;
  if OpenPictureDialog1.Execute then
    with MainForm.ChessBoardImg do
    begin
      MainForm.AggiornaImmagine;
      MainForm.SizesLbl.Caption := 'Dimensioni: ' +
        IntToStr(Picture.Bitmap.Width) + ',' +
        IntToStr(Picture.Bitmap.Height);
    end
*)

(* salva immagine
  SavePictureDialog1.InitialDir := getSavedir;
  SavePictureDialog1.Filter := BmpFilter;
  SavePictureDialog1.DefaultExt := BmpDefaultExt;
  SavePictureDialog1.Title := 'Dove devo salvare i pezzi neri?';
  if SavePictureDialog1.Execute then
    MainForm.BlackPiecesImg.Picture.SaveToFile(SavePictureDialog1.FileName);
  SavePictureDialog1.Title := 'Dove devo salvare i pezzi bianchi?';
  if SavePictureDialog1.Execute then
    MainForm.WhitePiecesImg.Picture.SaveToFile(SavePictureDialog1.FileName);
*)

procedure TClasseDati.NewActExecute(Sender: TObject);
begin
  RidisponiPezzi(false);
  with MainFrm do
  begin
    NumEdt.Text := '';
    AuthorEdt.Text := '';
    NomeFile := '';
    Caption := 'Senza nome - Matto in 2 mosse';
    MainFrm.PulisciMossa;
    AggiornaGrafica
  end;
  if assigned(DebugFrm) then DebugFrm.ChbEdit.Text := BoardString;
end;

procedure TClasseDati.OpenActExecute(Sender: TObject);
var
  number,author: string;
begin
  OpenDialogAll.InitialDir := getDisposizioniDir;
  OpenDialogAll.Filter := m2mFilter;
  OpenDialogAll.DefaultExt := m2mDefaultExt;
  if OpenDialogAll.Execute and
     LoadFromFile(OpenDialogAll.FileName,number,author) then
  begin
    with MainFrm do
    begin
      NumEdt.Text := number;
      AuthorEdt.Text := author;
      NomeFile := OpenDialogAll.Filename;
      Caption := ExtractFileName(NomeFile) + ' - Matto in 2 mosse';
      MainFrm.PulisciMossa;
      AggiornaGrafica
    end;
    if assigned(DebugFrm) then DebugFrm.ChbEdit.Text := BoardString;
  end
end;

procedure TClasseDati.SaveActExecute(Sender: TObject);
begin
  if NomeFile = '' then SaveAsActExecute(Sender)
  else
    SaveToFile(NomeFile,MainFrm.NumEdt.Text,MainFrm.AuthorEdt.Text);
end;

procedure TClasseDati.SaveAsActExecute(Sender: TObject);
begin
  with SaveDialogAll do
  begin
    InitialDir := getDisposizioniDir;
    Filter := m2mFilter;
    DefaultExt := m2mDefaultExt;
    if Execute then
    begin
      SaveToFile(FileName,MainFrm.NumEdt.Text,MainFrm.AuthorEdt.Text);
      NomeFile := Filename;
      MainFrm.Caption := ExtractFileName(Filename) + ' - Matto in 2 mosse';
    end
(*
        if Application.MessageBox(
          PChar(Filename + ' esiste gi.'#10#13'Sostituirlo?'),
                'Salva con nome',MB_YESNO or MB_ICONWARNING) = IDYES then
*)
  end
end;

procedure TClasseDati.FirstGfxActUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := MainFrm.Gfx.ChessboardFilename <> '';
end;

(*
procedure TClasseDati.ImportActExecute(Sender: TObject);
begin
  OpenDialogAll.InitialDir := getDisposizioniDir;
  OpenDialogAll.Filter := TxtFilter;
  OpenDialogAll.DefaultExt := TxtDefaultExt;
  if OpenDialogAll.Execute then
    ShowMessage('Funzione non ancora supportata')
end;
*)

procedure TClasseDati.ExportActExecute(Sender: TObject);
begin
//  if ExportDlgForm.ShowModal = mrOk then
//  begin
  SaveDialogAll.InitialDir := getDisposizioniDir;
  SaveDialogAll.Filter := TxtFilter;
  SaveDialogAll.DefaultExt := TxtDefaultExt;
  if SaveDialogAll.Execute then
  begin
    SaveToTextFile(SaveDialogAll.FileName)
  end
//  end
end;

procedure TClasseDati.ExitActExecute(Sender: TObject);
begin
  MainFrm.Close;
end;

procedure TClasseDati.SetupActExecute(Sender: TObject);
begin
  if Sender = GfxSetupAct then
    SetupFrm.PageControl1.ActivePageIndex := 1
  else if Sender = EngineSetupAct then
    SetupFrm.PageControl1.ActivePageIndex := 0
  else raise Exception.Create('Errore interno del programma');

  SetupFrm.PreviewGfxSet := MainFrm.Gfx;
  if SetupFrm.ShowModal = mrOk then
  begin
    SetupFrm.SalvaSuRegistro;
    with MainFrm do
    begin
      Gfx := SetupFrm.PreviewGfxSet;
      CaricaGrafica;
      AggiornaGrafica
    end
  end
end;

procedure TClasseDati.AboutActExecute(Sender: TObject);
begin
  FormAbout.ShowModal
end;

end.
