unit PezziU;

interface

uses Math,SysUtils,Classes,Utils,AlfabetaU;

{ probabilmente NextCode e DecodeMove andrebbero fuse }
function NextCode(Tipo: TTipoPezzo; Giocatore: TColore; Src: TCoords;
                  code: integer; First: boolean): integer;
function DecodeMove(Giocatore: TColore; Tipo: TTipoPezzo; Src: TCoords;
                      code: integer; var Coords: TCoords): boolean;
function canMove(Position: TAbstractPosition; Code: TMoveCode;
  Tipo: TTipoPezzo; Src: TCoords; Dst: TCoords): boolean;
function canTake(Giocatore: TColore; Position: TAbstractPosition;
  Code: TMoveCode; Tipo: TTipoPezzo;
  Src: TCoords; Dst: TCoords; var IdxMangiato: integer): boolean;
function RigaBase(Giocatore: TColore; riga: integer = 1): integer;
function CanPromove(Giocatore: TColore; Src: TCoords): boolean;
function minaccia(Giocatore: TColore;  Position: TAbstractPosition;
  Tipo: TTipoPezzo; Src: TCoords; Dst: TCoords): boolean;

implementation

uses PositionU;

(*
  case Tipo of
  t_pedone:
    HasMoved :=
      canMove(Position,IdxPezzo,SrcCoords,NextMove,DstCoords) or
      canTake(Position,IdxPezzo,SrcCoords,DstCoords) or
      EnPassant(Position,IdxPezzo,SrcCoords,NextMove) or
      Promozione(Position,IdxPezzo,SrcCoords,NextMove) or
      PromozionePresa(Position,IdxPezzo,SrcCoords,NextMove);
  t_torre:
    HasMoved :=
      canMove(Position,IdxPezzo,SrcCoords,NextMove,DstCoords) or
      canTake(Position,IdxPezzo,SrcCoords,DstCoords) or
      Arrocco(Position,IdxPezzo,SrcCoords,NextMove);
  t_cavallo,
  t_alfiere,
  t_re,
  t_regina:
    HasMoved :=
      canMove(Position,IdxPezzo,SrcCoords,NextMove,DstCoords) or
      canTake(Position,IdxPezzo,SrcCoords,DstCoords);
  else raise Exception.Create('Tipo di pezzo sconosciuto');
  end;
*)

procedure CalcolaCoords(Src: TCoords; Direction,Offset: byte; var X,Y: integer);
begin
  case Direction of
  1: begin X := Src.X - Offset; Y := Src.Y          end;
  2: begin X := Src.X - Offset; Y := Src.Y + Offset end;
  3: begin X := Src.X         ; Y := Src.Y + Offset end;
  4: begin X := Src.X + Offset; Y := Src.Y + Offset end;
  5: begin X := Src.X + Offset; Y := Src.Y          end;
  6: begin X := Src.X + Offset; Y := Src.Y - Offset end;
  7: begin X := Src.X         ; Y := Src.Y - Offset end;
  8: begin X := Src.X - Offset; Y := Src.Y - Offset end;
  end;
end;

{ guarda se le caselle tra la src e la dst sono libere - estremi esclusi }
function CaseOccupate(Pos: TPosition; Code: TMoveCode; Src: TCoords): boolean;
var
  Direction,Offset: byte;
  X,Y: integer;
  i: integer;
  Coords: TCoords;
begin
  Direction := Hi(Code);
  Offset := Lo(Code);
  result := false;
  for i := 1 to Offset-1 do
  begin
    CalcolaCoords(Src,Direction,i,X,Y);
    Coords.X := X; Coords.Y := Y;
    if Pos.CasaOccupata(Coords) then
    begin
      result := true;
      break;
    end
  end
end;

{ codice per la move/2 }
{ -------------------- }

function NextCode(Tipo: TTipoPezzo; Giocatore: TColore; Src: TCoords;
                  code: integer; First: boolean): integer;
  function IncCode(code, delta: integer; jump: boolean): integer;
  var
    Direction,Offset: byte;
  begin
    Direction := Hi(code);
    Offset := Lo(code);
    offset := (offset+1) mod 9;
    if jump or (offset = 0) then
    begin
      Inc(direction,delta);
      if direction > 8 then result := 0
      else result := (direction shl 8) + 1;
    end
    else result := (Direction shl 8) + Offset
  end;
var
 jump: boolean;
 Promosso,Mossa: byte;
begin
  { jump dice di cambiare direzione quando si controlla
    torre, alfiere, donna perch si  incontrato un ostacolo }
  if first then jump := false
  else
  begin
    case Tipo of
    t_pedone,t_re,t_cavallo: jump := false;
    t_regina,t_torre,t_alfiere: jump := true
    else raise Exception.Create('tipo sconosciuto')
    end;
  end;

  case Tipo of
  t_pedone:
    if CanPromove(Giocatore,Src) then
    begin
      Promosso := Hi(code);
      Mossa := Lo(code);
      if Promosso = 0 then result := (1 shl 8) + Mossa
      else result := (Mossa + 1) mod 5
    end
    else result := (code + 1) mod 5;
  t_re, t_cavallo: result := (code + 1) mod 9;
  t_regina:
    if code = 0 then result := (1 shl 8) + 1
    else result := IncCode(code,1,jump);
  t_torre:
   if (code = 0) or (code = 1) then result := code + 1
   else if (code = 2) then result := (1 shl 8) + 1
   else result := IncCode(code,2,jump);
  t_alfiere:
    if code = 0 then result := (2 shl 8) + 1
    else result := IncCode(code,2,jump);
  else raise Exception.Create('Tipo di pezzo sconosciuto');
  end;
end;

function DecodeMove(Giocatore: TColore; Tipo: TTipoPezzo; Src: TCoords;
                      code: integer; var Coords: TCoords): boolean;
var
  X,Y: integer;
  Direction,Offset: byte;
begin
  case Tipo of
  t_pedone:
    if Giocatore = bianco then
    begin
      case Lo(code) of
      1: begin X := Src.X; Y := Src.Y + 1 end;
      2: begin X := Src.X; Y := Src.Y + 2 end;
      3: begin X := Src.X - 1 ; Y := Src.Y + 1 end;
      4: begin X := Src.X + 1; Y := Src.Y + 1 end;
      end;
    end
    else
    begin
      case Lo(code) of
      1: begin X := Src.X; Y := Src.Y - 1 end;
      2: begin X := Src.X; Y := Src.Y - 2 end;
      3: begin X := Src.X - 1 ; Y := Src.Y - 1 end;
      4: begin X := Src.X + 1; Y := Src.Y - 1 end;
      end;
    end;
  t_cavallo:
    case code of
    1: begin X := Src.X - 2; Y := Src.Y + 1 end;
    2: begin X := Src.X - 1; Y := Src.Y + 2 end;
    3: begin X := Src.X + 2; Y := Src.Y + 1 end;
    4: begin X := Src.X + 1; Y := Src.Y + 2 end;
    5: begin X := Src.X - 2; Y := Src.Y - 1 end;
    6: begin X := Src.X - 1; Y := Src.Y - 2 end;
    7: begin X := Src.X + 2; Y := Src.Y - 1 end;
    8: begin X := Src.X + 1; Y := Src.Y - 2 end;
    end;
  t_re:
    CalcolaCoords(Src,code,1,X,Y);
  t_torre,
  t_alfiere,
  t_regina:
    if code = 1 then begin Y := Src.Y; X := 6 end { arrocco corto }
    else if code = 2 then begin Y := Src.Y; X := 4 end { arrocco lungo }
    else
    begin
      Direction := Hi(code);
      Offset := Lo(code);
      CalcolaCoords(Src,Direction,Offset,X,Y)
    end;
  else raise Exception.Create('Tipo di pezzo sconosciuto');
  end;

  if (X >= 1) and (X <= 8) and (Y >= 1) and (Y <= 8) then
  begin
    Coords.X := X;
    Coords.Y := Y;
    result := true
  end
  else result := false
end;

function canMove(Position: TAbstractPosition; Code: TMoveCode;
  Tipo: TTipoPezzo; Src: TCoords; Dst: TCoords): boolean;
    function PosizionePezziOk(Giocatore: TColore; Code: TMoveCode;
                              ReCoords,TorreCoords: TCoords): boolean;
    begin
      result :=
        { Re }
        (ReCoords.X = 5) and (ReCoords.Y = RigaBase(Giocatore)) and
        { Torre }
        (TorreCoords.Y = RigaBase(Giocatore)) and
                (((Code = 1) and (TorreCoords.X = 8)) or
                 ((Code = 2) and (TorreCoords.X = 1)))
    end;
var
  Miei,Avversari: TList;
  Avversario: TColore;
  Pos: TPosition;
  ReTipo: TTipoPezzo;
  ReCoords,Intermedia,CasaDst: TCoords;
  Delta1X,Delta2X: integer;
  CodeTorre: TMoveCode;
begin
  Pos := TPosition(Position);
  Pos.getPezzi(Pos.Giocatore,Miei,Avversari);

  case Tipo of
  t_pedone:
  begin
    Intermedia.X := Src.X;
    Intermedia.Y := RigaBase(Pos.Giocatore,3);
    result := (
                (Lo(code) = 1) or
                ((Lo(code) = 2) and (Src.Y = RigaBase(Pos.Giocatore,2))
                  and not Pos.CasaOccupata(Intermedia) )
              ) and not Pos.CasaOccupata(Dst);
  end;
  t_cavallo,
  t_re:
    result := not Pos.CasaOccupata(Dst);
  t_alfiere,
  t_regina:
    result := not Pos.CasaOccupata(Dst) and
              not CaseOccupate(Pos,Code,Src);
  t_torre:
    if (code = 1) or (code = 2) then
    begin
      if (code = 1) then
      begin
        { arrocco corto }
        Delta1X := 1; Delta2X := 2;
        CodeTorre := (1 shl 8) + 3;
      end
      else
      begin
      { arrocco lungo }
        Delta1X := -1; Delta2X := -2;
        CodeTorre := (5 shl 8) + 4;
      end;
      if Pos.Giocatore = bianco then Avversario := nero
      else Avversario := bianco;
      Pos.EstraiPezzo(Miei,0,ReTipo,ReCoords);
      Intermedia.X := ReCoords.X + Delta1X; Intermedia.Y := ReCoords.Y;
      CasaDst.X := ReCoords.X + Delta2X; CasaDst.Y := ReCoords.Y;
      result := PosizionePezziOk(Pos.Giocatore,Code,ReCoords,Src) and
                not CaseOccupate(Pos,CodeTorre,Src) and
                not Pos.Scacco(Avversario,Avversari,ReCoords) and
                not Pos.Scacco(Avversario,Avversari,Intermedia) and
                not Pos.Scacco(Avversario,Avversari,CasaDst);
    end
    else
      result := not Pos.CasaOccupata(Dst) and
                not CaseOccupate(Pos,Code,Src);
  else raise Exception.Create('Tipo di pezzo sconosciuto');
  end;
end;

function getTakeCode(Giocatore: TColore; Tipo: TTipoPezzo; Src: TCoords;
                  Dst: TCoords): integer;
  function CalcolaDirezione(Src,Dst: TCoords; MaxOffset: byte;
                            var Offset: byte): byte;
  var
    DeltaX,DeltaY: integer;
  begin
    DeltaX := Dst.X - Src.X;
    DeltaY := Dst.Y - Src.Y;
    Offset := max(abs(DeltaX),abs(DeltaY));
    if (Offset <= MaxOffset) and (Offset > 0) then
    begin
      if DeltaX = DeltaY then
      begin
        if DeltaX > 0 then result := 4 // ne
        else result := 8 // so
      end
      else if DeltaX = -DeltaY then
      begin
        if DeltaX > 0 then result := 6  // se
        else result := 2 // no
      end
      else if DeltaY = 0 then
      begin
        if DeltaX > 0 then result := 5 // e
        else result := 1 // o
      end
      else if DeltaX = 0 then
      begin
        if DeltaY > 0 then result := 3 // n
        else result := 7 // s
      end
      else result := 0 // non  sulle 8 direzioni
    end
    else result := 0
  end;
var
  Direction,Offset: byte;
begin
  case Tipo of
  t_pedone:
    if Giocatore = bianco then
    begin
      if (Dst.X = Src.X - 1) and (Dst.Y = Src.Y + 1) then result := 3
      else if (Dst.X = Src.X + 1) and (Dst.Y = Src.Y + 1) then result := 4
      else result := 0
    end
    else
    begin
      if (Dst.X = Src.X - 1) and (Dst.Y = Src.Y - 1) then result := 3
      else if (Dst.X = Src.X + 1) and (Dst.Y = Src.Y - 1) then result := 4
      else result := 0
    end;
  t_cavallo:
    if (Dst.X = Src.X - 2) and (Dst.Y = Src.Y + 1) then result := 1
    else if (Dst.X = Src.X - 1) and (Dst.Y = Src.Y + 2) then result := 2
    else if (Dst.X = Src.X + 2) and (Dst.Y = Src.Y + 1) then result := 3
    else if (Dst.X = Src.X + 1) and (Dst.Y = Src.Y + 2) then result := 4
    else if (Dst.X = Src.X - 2) and (Dst.Y = Src.Y - 1) then result := 5
    else if (Dst.X = Src.X - 1) and (Dst.Y = Src.Y - 2) then result := 6
    else if (Dst.X = Src.X + 2) and (Dst.Y = Src.Y - 1) then result := 7
    else if (Dst.X = Src.X + 1) and (Dst.Y = Src.Y - 2) then result := 8
    else result := 0;
  t_re:
    result := CalcolaDirezione(Src,Dst,1,offset);
  t_torre:
  begin
    direction := CalcolaDirezione(Src,Dst,8,offset);
    if (direction mod 2) = 1 then
      result := (direction shl 8) + offset
    else result := 0
  end;
  t_alfiere:
  begin
    direction := CalcolaDirezione(Src,Dst,8,offset);
    if (direction <> 0) and ((direction mod 2) = 0) then
      result := (direction shl 8) + offset
    else result := 0
  end;
  t_regina:
  begin
    direction := CalcolaDirezione(Src,Dst,8,offset);
    if (direction <> 0) then
      result := (direction shl 8) + offset
    else result := 0
  end;
  else raise Exception.Create('Tipo di pezzo sconosciuto');
  end;
end;

function canTake(Giocatore: TColore; Position: TAbstractPosition;
  Code: TMoveCode; Tipo: TTipoPezzo;
  Src: TCoords; Dst: TCoords; var IdxMangiato: integer): boolean;
var
  Miei,Avversari: TList;
  Pos: TPosition;
  IdxPedone: integer;
  TipoPedone: TTipoPezzo;
  CoordsPedone,PartenzaPedone: TCoords;
begin
  Pos := TPosition(Position);
  Pos.getPezzi(Giocatore,Miei,Avversari);

  case Tipo of
  t_pedone:
    if (Lo(code) = 3) or (Lo(code) = 4) then
    begin
      IdxMangiato := Pos.CercaPezzo(Avversari,Dst);
      if IdxMangiato <> - 1 then result := true
      else if Src.Y = RigaBase(Pos.Giocatore,5) then
      begin
        { controlla presa en-passant }
        CoordsPedone.X := Dst.X; CoordsPedone.Y := Src.Y;
        PartenzaPedone.X := Dst.X;
        PartenzaPedone.Y := RigaBase(Pos.Giocatore,2);
        IdxPedone := Pos.CercaPezzo(Avversari,CoordsPedone);
        if (IdxPedone <> -1) and
           not Pos.CasaOccupata(Dst) and
           not Pos.CasaOccupata(PartenzaPedone) then
        begin
          Pos.EstraiPezzo(Avversari,IdxPedone,TipoPedone,CoordsPedone);
          if TipoPedone = t_pedone then
          begin
            IdxMangiato := IdxPedone; result := true
          end
          else
          begin
            IdxMangiato := -1; result := false;
          end
        end
        else
        begin
          IdxMangiato := -1; result := false;
        end
      end
      else result := false;
    end
    else result := false;
  t_cavallo,
  t_re:
  begin
    IdxMangiato := Pos.CercaPezzo(Avversari,Dst);
    result := IdxMangiato <> -1
  end;
  t_torre,
  t_alfiere,
  t_regina:
    if (tipo = t_torre) and (code <= 2) then
      result := false
    else
    begin
      IdxMangiato := Pos.CercaPezzo(Avversari,Dst);
      if (IdxMangiato <> -1) and
         not CaseOccupate(Pos,Code,Src) then
        result := true
      else
      begin
        IdxMangiato := -1; result := false;
      end
    end;
  else raise Exception.Create('Tipo di pezzo sconosciuto');
  end;
end;

{ codice per la move/3 }
{ -------------------- }
{ controllo scacco }

function canMenace(Giocatore: TColore; Position: TAbstractPosition;
  Code: TMoveCode; Tipo: TTipoPezzo;
  Src: TCoords; Dst: TCoords): boolean;
var
  Miei,Avversari: TList;
  Pos: TPosition;
begin
  Pos := TPosition(Position);
  Pos.getPezzi(Giocatore,Miei,Avversari);

  case Tipo of
  t_pedone:
    if (Lo(code) = 3) or (Lo(code) = 4) then result := true
    else result := false;
  t_cavallo,
  t_re: result := true;
  t_torre,
  t_alfiere,
  t_regina:
    if (tipo = t_torre) and (code <= 2) then
      result := false
    else
      result := not CaseOccupate(Pos,Code,Src);
  else raise Exception.Create('Tipo di pezzo sconosciuto');
  end;
end;

function minaccia(Giocatore: TColore; Position: TAbstractPosition;
  Tipo: TTipoPezzo; Src: TCoords; Dst: TCoords): boolean;
var
  Code: TMoveCode;
begin
  Code := getTakeCode(Giocatore,Tipo,Src,Dst);
  if (Code <> 0) and
     canMenace(Giocatore,Position,Code,Tipo,Src,Dst) then
    result := true
  else result := false
end;

{ utils pubbliche }

function RigaBase(Giocatore: TColore; riga: integer = 1): integer;
begin
  if Giocatore = bianco then result := riga
  else result := 9-riga
end;

function CanPromove(Giocatore: TColore; Src: TCoords): boolean;
begin
  result := ((Giocatore = bianco) and (Src.Y = 7)) or
            ((Giocatore = nero) and (Src.Y = 2))
end;

end.
