unit Utils;

interface

type
  TMoveCode = type word;
  // potevo anche usare TPoint
  TCoords = record
    X,Y: integer
  end;
  TTipoPezzo = (t_torre,t_cavallo,t_alfiere,t_regina,t_re,t_pedone);
  TColore = (nero,bianco);

const
  s_mossa_illegale = 'nil';
  // arrocchi
  s_arrocco_corto = 'o-o';
  s_arrocco_lungo = 'o-o-o';
  // simboli vari
  s_promozione = '!';   // promozione pedone
  s_presa = 'x';
  s_scacco = '+';       // non usato!
  s_scacco_matto = '#';
  s_separatore = '';    // separa src-dest (trattino o niente)
  s_virgola = ',';      // separa pezzi o mosse
  // pezzi
  s_torre = 'T';
  s_cavallo = 'C';
  s_alfiere = 'A';
  s_regina = 'D';
  s_re = 'R';
  s_pedone = 'P';

{ dato un colore e un pezzo ritorna il carattere }
function getCharFromPezzo(t: TTipoPezzo; cl: TColore): char;
{ dato un carattere ritorna il colore e il pezzo }
function getPezzoFromChar(ch: char; var t: TTipoPezzo; var cl: TColore): boolean;
{ legge un carattere da '1' a '8' }
function parse_Y(chY: char; var Y: integer): boolean;
{ legge un carattere da '1' a '8' o da 'a' a 'h' }
function parse_X(chX: char; var X: integer): boolean;
{ codifica coordinata X }
function code_X(X: integer): char;
{ codifica coordinata Y }
function code_Y(Y: integer): char;

implementation

const
  { questi caratteri definiscono l'interfaccia col motore e
    NON devono essere modificabili dall'utente }
  PieceChars: array[TColore,TTipoPezzo] of char =
    (('t','c','a','d','r','p'),
    ('T','C','A','D','R','P'));

function getCharFromPezzo(t: TTipoPezzo; cl: TColore): char;
begin
  result := PieceChars[cl,t]
end;

function getPezzoFromChar(ch: char; var t: TTipoPezzo; var cl: TColore): boolean;
var
  pl: TColore;
  p: TTipoPezzo;
begin
  result := false;
  for pl := Low(TColore) to High(TColore) do
    for p := Low(TTipoPezzo) to High(TTipoPezzo) do
      if ch = PieceChars[pl,p] then
      begin
        result := true;
        cl := pl;
        t := p;
        break
      end
end;

function parse_Y(chY: char; var Y: integer): boolean;
begin
  if (chY >= '1') and (chY <= '8') then
  begin
    Y := ord(chY) - ord('0');
    result := true
  end
  else result := false
end;

function parse_X(chX: char; var X: integer): boolean;
begin
  if (chX >= '1') and (chX <= '8') then
  begin
    X := ord(chX) - ord('0');
    result := true
  end
  else if (chX >= 'a') and (chX <= 'h') then
  begin
    X := ord(chX) - ord('a') + 1;
    result := true
  end
  else result := false
end;

{ codifica coordinata X }
function code_X(X: integer): char;
begin
  result := char(X + ord('0'))
//  result := char(X + ord('a') - 1)
end;

{ codifica coordinata Y }
function code_Y(Y: integer): char;
begin
  result := char(Y + ord('0'))
end;


end.
