% test
% programma di prova del filetto

user:file_search_path(engine,'../engine').
:- [regole].
:- [engine(minimax),
    engine(alfabeta)].

% algoritmi a confronto
f(Scacchiera) :-
  ab(Scacchiera), m(Scacchiera), ms(Scacchiera).

% algoritmi presi uno a uno
ab(Scacchiera) :-
  ab(Scacchiera,none).
ab(Scacchiera,Mode) :-
  chiama_algoritmo(alfabeta,9,Scacchiera,Mode).
m(Scacchiera) :-
  m(Scacchiera,none).
m(Scacchiera,Mode) :-
  chiama_algoritmo(minimax,9,Scacchiera,Mode).
ms(Scacchiera) :-
  ms(Scacchiera,none).
ms(Scacchiera,Mode) :-
  chiama_algoritmo(minimax_simple,9,Scacchiera,Mode).

chiama_algoritmo(Algoritmo,MaxDepth,Scacchiera,Mode) :-
  writeNoDebug(Mode,'Elaboro con %w...',[Algoritmo]),
  flush_output,
  statistics(runtime,_),
  computer_move(Algoritmo,MaxDepth,Scacchiera,Move,Value,Mode),
%  computer_choice(Algoritmo,MaxDepth,Scacchiera,List,Mode),
  statistics(runtime,[_,Time]),
  writeNoDebug(Mode,'\r',[]),
  writef('%w: %w,%w (%w millisecondi)\n',[Algoritmo,Move,Value,Time]).
%  writef('%w: %w (%w millisecondi)\n',[Algoritmo,L,T]).

writeNoDebug(none,S,P) :- writef(S,P).
writeNoDebug(normal,_,_).
writeNoDebug(extra,_,_).
















