%//////////////////////////////////////
%//            MOSSA ALFIERE        //
%/////////////////////////////////////


mossa_alfiere(Position,(X0,Y0),(X,Y)):-
   mossa_alfiereP(Position,(X0,Y0),(X,Y));
   mossa_alfiereS(Position,(X0,Y0),(X,Y)).


mossa_alfiereP(Position,(X0,Y0),(X,Y)):-
    calcolaDsup(X0,Y0,Dx,Dy),
    calcolaDinf(X0,Y0,Dix,Diy),
    merge_pieces(Position,U),
    cercaP(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin),
    between(Xmin,Xmax,X),
       X =\= X0,
    (	between(Ymin,Ymax,Y),
      (	  (X0>X0)-> X-Y=:=X0-Y0;
           Y- X=:=Y0-X0)).
    
mossa_alfiereS(Position,(X0,Y0),(X1,Y1)):-
    calcolaSsup(X0,Y0,Sx,Sy),
    calcolaSinf(X0,Y0,Six,Siy),
    merge_pieces(Position,U),
    cercaS(U,X0,Y0,Sx,Sy,Six,Siy,Xma,Yma,Xmi,Ymi),
    ( between(Xma,Xmi,X1),
       X1 =\= X0,
    ( between(Ymi,Yma,Y1),
      (	  
	 X1+Y1=:=X0+Y0
           ))).






cercaP(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   X0>=Y0,
   cerca1(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

cercaP(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   X0<Y0,
   cerca2(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).
   
cercaS(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   X0+Y0=<9,
   cerca3(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

cercaS(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   X0+Y0>9,
   cerca4(U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).
 

%/////////////////////////////////////////////////////////
%//  CERCA I LIMITI SOTT LA DIAG PRINCIPALE //
%/////////////////////////////////////////////////////////    



cerca1([],_,_,Dx,Dy,Dix,Diy,Dx,Dy,Dix,Diy).
   
         
cerca1([(_,X,Y)|Coda],X0,Y0,Dx,_,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   X0>=Y0,
   X-Y=:=X0-Y0, 
   X=<Dx,X>X0,
   Dx1 is X-1,
   Dy1 is Y-1,!,
   cerca1(Coda,X0,Y0,Dx1,Dy1,Dix,Diy,Xmax,Ymax,Xmin,Ymin).
   
cerca1([(_,X,Y)|Coda],X0,Y0,Dx,Dy,Dix,_,Xmax,Ymax,Xmin,Ymin):-
   X0>=Y0,
   X-Y=:=X0-Y0, 
   X>=Dix,X<X0,
   Dix1 is X+1,
   Diy1 is Y+1,!,
   cerca1(Coda,X0,Y0,Dx,Dy,Dix1,Diy1,Xmax,Ymax,Xmin,Ymin).

cerca1([(_,_,_)|Coda],X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   !,X0>=Y0, 
   cerca1(Coda,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).



%//////////////////////////////////////////////////////
%//  CERCA I LIMITI SOPRA LA DIAG PRINCIPALE //
%//////////////////////////////////////////////////////    


cerca2([],_,_,Dx,Dy,Dix,Diy,Dx,Dy,Dix,Diy).
            
cerca2([(_,X,Y)|Coda],X0,Y0,Dx,_,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   X0<Y0,
   Y - X=:=Y0-X0, 
   X=<Dx,X>X0,
   Dx1 is X-1,
   Dy1 is Y-1,!,
   cerca2(Coda,X0,Y0,Dx1,Dy1,Dix,Diy,Xmax,Ymax,Xmin,Ymin).
   
cerca2([(_,X,Y)|Coda],X0,Y0,Dx,Dy,Dix,_,Xmax,Ymax,Xmin,Ymin):-
   X0<Y0,
   Y - X=:=Y0-X0, 
   X>=Dix,X<X0,
   Dix1 is X+1,
   Diy1 is Y+1,!,
   cerca2(Coda,X0,Y0,Dx,Dy,Dix1,Diy1,Xmax,Ymax,Xmin,Ymin).

cerca2([(_,_,_)|Coda],X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   !, 
   X0<Y0,
   cerca2(Coda,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).


%//////////////////////////////////////////////////////////
%//  CERCA I LIMITI SOTTO LA DIAG SECONDARIA //
%//////////////////////////////////////////////////////////    


cerca3([],_,_,Sx,Sy,Six,Siy,Sx,Sy,Six,Siy).
            
cerca3([(_,X,Y)|Coda],X0,Y0,Sx,_,Six,Siy,Xmax,Ymax,Xmin,Ymin):-
   (X0+Y0) =<9,
   X+Y=:=X0+Y0, 
   X>=Sx,
   X<X0,
   Sx1 is X+1,
   Sy1 is Y-1,!,
   cerca3(Coda,X0,Y0,Sx1,Sy1,Six,Siy,Xmax,Ymax,Xmin,Ymin).
   

cerca3([(_,X,Y)|Coda],X0,Y0,Sx,Sy,Six,_,Xmax,Ymax,Xmin,Ymin):-
    ( X0+Y0)=<9 ,
   X+Y=:=X0+Y0, 
   X =< Six,
   X > X0,
   Six1 is X-1,
   Siy1 is Y+1,!,
   cerca3(Coda,X0,Y0,Sx,Sy,Six1,Siy1,Xmax,Ymax,Xmin,Ymin).

cerca3([(_,_,_)|Coda],X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   !,    
   cerca3(Coda,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).   



%//////////////////////////////////////////////////////////
%//  CERCA I LIMITI SOPRA LA DIAG SECONDARIA //
%//////////////////////////////////////////////////////////    


  
cerca4([],_,_,Sx,Sy,Six,Siy,Sx,Sy,Six,Siy).
            
cerca4([(_,X,Y)|Coda],X0,Y0,Sx,_,Six,Siy,Xmax,Ymax,Xmin,Ymin):-
   (X0+Y0)>9,
   X+Y=:=X0+Y0, 
   X>=Sx,
   X<X0,
   Sx1 is X+1,
   Sy1 is Y-1,!,
   cerca4(Coda,X0,Y0,Sx1,Sy1,Six,Siy,Xmax,Ymax,Xmin,Ymin).
   

cerca4([(_,X,Y)|Coda],X0,Y0,Sx,Sy,Six,_,Xmax,Ymax,Xmin,Ymin):-
    ( X0+Y0)>9 ,
   X+Y=:=X0+Y0, 
   X =< Six,
   X > X0,
   Six1 is X-1,
   Siy1 is Y+1,!,
   cerca4(Coda,X0,Y0,Sx,Sy,Six1,Siy1,Xmax,Ymax,Xmin,Ymin).

cerca4([(_,_,_)|Coda],X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   !,    
   cerca4(Coda,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).   
  

/*
 limitiMax(X0,Y0,(Dmax,Dma),(Dmin,Dmi),(Smax,Sma),(Smin,Smi)):-
    calcolaDsup(X0,Y0,Dmax,Dma),
    calcolaDinf(X0,Y0,Dmin,Dmi), 
    calcolaSsup(X0,Y0,Smax,Sma),
    calcolaSinf(X0,Y0,Smin,Smi). 
*/
 
%/////////////////////////////////////
%   DIAGONALE PRINCIPALE
%//////////////////////////////////////
  
  
  calcolaDsup(X0,Y0,Xmax,Ymax):-
    X0>=Y0,
    Xmax is 8,
    Ymax is (Xmax + Y0-X0).
  calcolaDsup(X0,Y0,Xmax,Ymax):-
    X0<Y0,
    Ymax is 8,
    Xmax is (Ymax + X0-Y0).
  calcolaDinf(X0,Y0,Xmin,Ymin):-
    X0<Y0,
    Xmin is 1,
    Ymin is (Y0 +Xmin -X0).
  calcolaDinf(X0,Y0,Xmin,Ymin):-
    X0>=Y0,
    Ymin is 1,
    Xmin is (X0 +Ymin - Y0).


  
%/////////////////////////////////////////
%     DIAGONALE SECONDARIA
%/////////////////////////////////////////

  calcolaSsup(X0,Y0,Xmax,Ymax):-
     (X0+Y0) =<9,
     Xmax is 1,
     Ymax is (X0+Y0 - Xmax).
     
  calcolaSsup(X0,Y0,Xmax,Ymax):-
     (X0+Y0) > 9,
     Ymax is 8,
     Xmax is ( X0+Y0- Ymax).
     
  calcolaSinf(X0,Y0,Xmin,Ymin):-
     (X0+Y0) =<9,
     Ymin is 1,
     Xmin is (X0+Y0 - Ymin).
     
  calcolaSinf(X0,Y0,Xmin,Ymin):-
     (X0+Y0) > 9,
     Xmin is 8,
     Ymin is ( X0+Y0- Xmin).
  

%/////////////////////////////////////
%//            PRESA ALFIERE        //
%/////////////////////////////////////

presa_alfiere(Giocatore,Scacchiera,(X0,Y0),_,Idx,(X,Y)) :-
 pieces(Giocatore,Scacchiera,Proprio,Avversario),
 presa_alfiereP(Avversario,Proprio,(X0,Y0),Idx,(X,Y)).

presa_alfiere(Giocatore,Scacchiera,(X0,Y0),_,Idx,(X,Y)) :-
 pieces(Giocatore,Scacchiera,Proprio,Avversario),
 presa_alfiereS(Avversario,Proprio,(X0,Y0),Idx,(X,Y)).


presa_alfiereP(Avversario,Proprio,(X0,Y0),Idx,(X,Y)):-
 calcolaDsup(X0,Y0,Dx,Dy),
 calcolaDinf(X0,Y0,Dix,Diy),
 merge_pieces((Avversario,Proprio),U),
 cercapresaP(Avversario,U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,_,_),
 restituisci1(Avversario,Xmax,Ymax,Dx,Dy,X,Y,Idx).

presa_alfiereP(Avversario,Proprio,(X0,Y0),Idx,(X,Y)):-
 calcolaDsup(X0,Y0,Dx,Dy),
 calcolaDinf(X0,Y0,Dix,Diy),
 merge_pieces((Avversario,Proprio),U),
 cercapresaP(Avversario,U,X0,Y0,Dx,Dy,Dix,Diy,_,_,Xmin,Ymin),
 restituisci2(Avversario,Xmin,Ymin,Dix,Diy,X,Y,Idx).

restituisci1(Pezzi,Xmax,Ymax,_,_,X,Y,Idx):-
 ( (memberchk((Idx,Xmax,Ymax),Pezzi) )-> X is Xmax,Y is Ymax).

restituisci2(Pezzi,Xmin,Ymin,_,_,X,Y,Idx):-
( ( memberchk((Idx,Xmin,Ymin),Pezzi))->X is Xmin,Y is Ymin ).


presa_alfiereS(Avversario,Proprio,(X0,Y0),Idx,(X,Y)):-
 calcolaSsup(X0,Y0,Sx,Sy),
 calcolaSinf(X0,Y0,Six,Siy),
 merge_pieces((Avversario,Proprio),U),
 cercapresaS(Avversario,U,X0,Y0,Sx,Sy,Six,Siy,Xmax,Ymax,_,_),
 restituisci1(Avversario,Xmax,Ymax,Sx,Sy,X,Y,Idx).


presa_alfiereS(Avversario,Proprio,(X0,Y0),Idx,(X,Y)):-
 calcolaSsup(X0,Y0,Sx,Sy),
 calcolaSinf(X0,Y0,Six,Siy),
 merge_pieces((Avversario,Proprio),U),
 cercapresaS(Avversario,U,X0,Y0,Sx,Sy,Six,Siy,_,_,Xmin,Ymin),
 restituisci2(Avversario,Xmin,Ymin,Six,Siy,X,Y,Idx).


cercapresaP(Avversario,U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   X0>=Y0,
   cercapresa1(Avversario,U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

cercapresaP(Avversario,U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   X0<Y0,
   cercapresa2(Avversario,U,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

cercapresaS(Avversario,U,X0,Y0,Sx,Sy,Six,Siy,Xmax,Ymax,Xmin,Ymin):-
   X0+Y0=<9,
   cercapresa3(Avversario,U,X0,Y0,Sx,Sy,Six,Siy,Xmax,Ymax,Xmin,Ymin).

cercapresaS(Avversario,U,X0,Y0,Sx,Sy,Six,Siy,Xmax,Ymax,Xmin,Ymin):-
   X0+Y0>9,
   cercapresa4(Avversario,U,X0,Y0,Sx,Sy,Six,Siy,Xmax,Ymax,Xmin,Ymin).



%/////////////////////////////////////////////////////////
%//  CERCA I LIMITI SOTT LA DIAG PRINCIPALE //
%/////////////////////////////////////////////////////////



cercapresa1(_,[],_,_,Dx1,Dy1,Dix1,Diy1,Dx1,Dy1,Dix1,Diy1).
%  nl, writef('Mangia'),nl.


cercapresa1(A,[(_,X,Y)|Coda],X0,Y0,Dx,_,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
 % X0>=Y0,
   X-Y=:=X0-Y0,
   X=<Dx,X>X0,
   Dx1 is X,
   Dy1 is Y,!,
   cercapresa1(A,Coda,X0,Y0,Dx1,Dy1,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

cercapresa1(A,[(_,X,Y)|Coda],X0,Y0,Dx,Dy,Dix,_,Xmax,Ymax,Xmin,Ymin):-
 % X0>=Y0,
   X-Y=:=X0-Y0,
   X>=Dix,X<X0,
   Dix1 is X,
   Diy1 is Y,!,
   cercapresa1(A,Coda,X0,Y0,Dx,Dy,Dix1,Diy1,Xmax,Ymax,Xmin,Ymin).

cercapresa1(A,[(_,_,_)|Coda],X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   !,X0>=Y0,
   cercapresa1(A,Coda,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

%//////////////////////////////////////////////////////
%//  CERCA I LIMITI SOPRA LA DIAG PRINCIPALE //
%//////////////////////////////////////////////////////


cercapresa2(_,[],_,_,Dx,Dy,Dix,Diy,Dx,Dy,Dix,Diy).
%  nl,writef('Mangia '),nl.

cercapresa2(A,[(_,X,Y)|Coda],X0,Y0,Dx,_,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
  % X0<Y0,
   Y - X=:=Y0-X0,
   X=<Dx,X>X0,
   Dx1 is X,
   Dy1 is Y,!,
   cercapresa2(A,Coda,X0,Y0,Dx1,Dy1,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

cercapresa2(A,[(_,X,Y)|Coda],X0,Y0,Dx,Dy,Dix,_,Xmax,Ymax,Xmin,Ymin):-
  % X0<Y0,
   Y - X=:=Y0-X0,
   X>=Dix,X<X0,
   Dix1 is X,
   Diy1 is Y,!,
   cercapresa2(A,Coda,X0,Y0,Dx,Dy,Dix1,Diy1,Xmax,Ymax,Xmin,Ymin).

cercapresa2(A,[(_,_,_)|Coda],X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   !,
   X0<Y0,
   cercapresa2(A,Coda,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).



cercapresa3(_,[],_,_,Sx,Sy,Six,Siy,Sx,Sy,Six,Siy).

cercapresa3(A,[(_,X,Y)|Coda],X0,Y0,Sx,_,Six,Siy,Xmax,Ymax,Xmin,Ymin):-
 % (X0+Y0) =<9,
   X+Y=:=X0+Y0,
   X>=Sx,
   X<X0,
   Sx1 is X,
   Sy1 is Y,!,
   cercapresa3(A,Coda,X0,Y0,Sx1,Sy1,Six,Siy,Xmax,Ymax,Xmin,Ymin).


cercapresa3(A,[(_,X,Y)|Coda],X0,Y0,Sx,Sy,Six,_,Xmax,Ymax,Xmin,Ymin):-
 % ( X0+Y0)=<9 ,
   X+Y=:=X0+Y0,
   X =< Six,
   X > X0,
   Six1 is X,
   Siy1 is Y,!,
   cercapresa3(A,Coda,X0,Y0,Sx,Sy,Six1,Siy1,Xmax,Ymax,Xmin,Ymin).

cercapresa3(A,[(_,_,_)|Coda],X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   !,
   cercapresa3(A,Coda,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

cercapresa4(_,[],_,_,Sx,Sy,Six,Siy,Sx,Sy,Six,Siy).

cercapresa4(A,[(_,X,Y)|Coda],X0,Y0,Sx,_,Six,Siy,Xmax,Ymax,Xmin,Ymin):-
 % (X0+Y0) =<9,
   X+Y=:=X0+Y0,
   X>=Sx,
   X<X0,
   Sx1 is X,
   Sy1 is Y,!,
   cercapresa4(A,Coda,X0,Y0,Sx1,Sy1,Six,Siy,Xmax,Ymax,Xmin,Ymin).


cercapresa4(A,[(_,X,Y)|Coda],X0,Y0,Sx,Sy,Six,_,Xmax,Ymax,Xmin,Ymin):-
 % ( X0+Y0)=<9 ,
   X+Y=:=X0+Y0,
   X =< Six,
   X > X0,
   Six1 is X,
   Siy1 is Y,!,
   cercapresa4(A,Coda,X0,Y0,Sx,Sy,Six1,Siy1,Xmax,Ymax,Xmin,Ymin).

cercapresa4(A,[(_,_,_)|Coda],X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin):-
   !,
   cercapresa4(A,Coda,X0,Y0,Dx,Dy,Dix,Diy,Xmax,Ymax,Xmin,Ymin).

