% 1) legal_position(+Position)
% ----------------------------
% stabilisce se la scacchiera  legale
/*
CONTROLLI:
1 - Position = (Giocatore,Scacchiera)?
2 - Giocatore = bianco|nero? Scacchiera = (Neri,Bianchi)?
3 - Neri e Bianchi sono 2 vettori di max 16 elem. di triple?
4 - ogni tripla  costituita da Tipo,X,Y corretti? 
    (Tipo=torre,cavallo,alfiere,regina,re,pedone,1<=X,Y<=8)
5 - esistono coppie di coordinate duplicate?
6 - i re esistono e sono in testa? non ci sono altri re?
CONTROLLI NON EFFETTUATI:
1 - se ci sono pi pezzi di un tipo di quelli possibili (l'unico controllo  sui re)
    Questo permette di testare il motore con situazioni poco verosimili
*/

% da rimuovere e mettere nel chiamante
:- [utils].

% controlla
% 1 - se Position = (Giocatore,(Neri,Bianchi))
% 2 - se i vettori sono costruiti bene (vedi dopo)
% 3 - se ci sono pi pezzi in una casella
legal_position((Giocatore,(Neri,Bianchi))) :- 
  player(Giocatore),
  vettore_legale(Neri), vettore_legale(Bianchi),
  estrai_coordinate(Neri,L1),
  estrai_coordinate(Bianchi,L2),
  append(L1,L2,Coordinate),
  is_set(Coordinate),!.

% vettore_legale(+Pezzi)
% controlla:
% 1 - se la lunghezza del vettore <= 16
% 2 - se le triple sono ben costruite (vedi dopo)
% 3 - se i re sono in testa e non ci sono altri re
vettore_legale(Pezzi) :- 
  length(Pezzi,Len),Len =< 16,
  legal_vettore(Pezzi),
  controllo_re(Pezzi).
%  estrai_indici(Pezzi,L), is_set(L).

% legal_vettore(+Pezzi)
% controlla se gli elementi dell'array sono nel range
legal_vettore([]).
legal_vettore([(Pezzo,X,Y)|C]) :-
  tipo(Pezzo), in_range(X), in_range(Y),
  legal_vettore(C).

% controllo_re(+Pezzi)
% 1 - il re  il primo elemento?
% 2 - non ci sono altri re?
controllo_re([(re,_,_)|Altri]) :- nessun_re(Altri).
nessun_re([(Pezzo,_,_)|Altri]) :- Pezzo \= re, !, nessun_re(Altri).
nessun_re([]).

% estrai_pezzi(+Pezzi,-List)
% estrae i tipi da Pezzi
/*
estrai_pezzi([],[]).
estrai_pezzi([(Idx,_,_)|C],[Idx|List]) :- estrai_pezzi(C,List).
*/

% estrai_coordinate(+Pezzi,-List)
% estrae le coordinate da Pezzi
estrai_coordinate([],[]).
estrai_coordinate([(_,X,Y)|C],[(X,Y)|List]) :- estrai_coordinate(C,List).











