% move(+Move,+OldPosition,-NewPosition)
% -------------------------------------
% data la mossa aggiorna la posizione
%
% Move = (Mosso,Compagno,Trasformato,Mangiato)
% dove
% Mosso = (Pezzo,Src,Dst)  il pezzo mosso
% Compagno = nil|(Pezzo,Src,Dst)  il pezzo mosso insieme nell'arrocco
% (il principale  la torre e il compagno  il re)
% Trasformato = nil|NuovoPezzo  il pezzo in cui si trasforma il pedone
% Mangiato = nil|(Pezzo,Pos)  l'eventuale pezzo mangiato
% Src,Dst,Pos sono coppie di coordinate (X,Y)
%
% Position = (Giocatore,Scacchiera)
% dove
% Giocatore = nero|bianco
% Scacchiera = (Neri,Bianchi)  l'insieme dei pezzi sulla scacchiera

% da spostare nel chiamante

%:-[utils].

move((Mosso,Compagno,Trasformato,Mangiato),(OldG,OldS),(NewG,NewS)) :-
  pieces(OldG,OldS,OldMiei,OldAltri),
  muovi_pezzo(Mosso,OldMiei,M1),
  muovi_pezzo(Compagno,M1,M2),
  trasforma_pezzo(Mosso,Trasformato,M2,NewMiei),
  mangia_pezzo(Mangiato,OldAltri,NewAltri),
  opponent(OldG,NewG),
  pieces(OldG,NewS,NewMiei,NewAltri).

% muovi_pezzo(+Mosso,+OldPezzi,-NewPezzi)
muovi_pezzo(nil,Pezzi,Pezzi) :- !.
muovi_pezzo((Pezzo,Src,Dst),OldPezzi,NewPezzi) :-
  remove_piece(Src,OldPezzi,P1),
  insert_piece(Pezzo,Dst,P1,NewPezzi).

% trasforma_pezzo(+Mosso,+Trasformato,+OldPezzi,-NewPezzi)
trasforma_pezzo(_,nil,Pezzi,Pezzi) :- !.
trasforma_pezzo((_,_,Dst),Trasformato,OldPezzi,NewPezzi) :-
  remove_piece(Dst,OldPezzi,P1),
  insert_piece(Trasformato,Dst,P1,NewPezzi).

% mangia_pezzo(+Mangiato,+OldPezzi,-NewPezzi)
mangia_pezzo(nil,Pezzi,Pezzi) :- !.
mangia_pezzo((_,Src),OldPezzi,NewPezzi) :-
  remove_piece(Src,OldPezzi,NewPezzi).














