
%/////////////////////////////////
%//        MOSSA TORRE		//
%/////////////////////////////////

% la torre si muove in verticale
mossa_torre(Position,(X0,Y0),(X0,Y)) :-
  merge_pieces(Position,U),
  limiti_torreV(U,X0,Y0,Yt,Yb),
  between(Yb,Yt,Y),
  Y =\= Y0.
% la torre si muove in orizzontale
mossa_torre(Position,(X0,Y0),(X,Y0)) :-
  merge_pieces(Position,U),
  limiti_torreO(U,X0,Y0,Xt,Xb),
  between(Xb,Xt,X),
  X =\= X0.




%///////////////////////////////////////////
%//      LIMITI TORRE VERTICALE           //
%///////////////////////////////////////////

limiti_torreV(U,X0,Y0,Yup,Ydown):-
   cercaV(U,X0,Y0,8,1,Yup,Ydown).

cercaV([],_,_,Up,Down,Up,Down).

cercaV([(_,X,Y)|C],X,YF,Up,Down,Max,Min):-
  Y=<Up,Y>YF,
  Up1 is Y-1,!,
  cercaV(C,X,YF,Up1,Down,Max,Min).

cercaV([(_,X,Y)|C],X,YF,Up,Down,Max,Min):-
  Y>=Down,Y<YF,
  Down1 is Y+1,!,
  cercaV(C,X,YF,Up,Down1,Max,Min).

cercaV([(_,_,_)|C],XF,YF,Up,Down,Max,Min):-
  cercaV(C,XF,YF,Up,Down,Max,Min).


%///////////////////////////////////////////////////////
%//      LIMITI TORRE ORIZZONTALE         //
%//////////////////////////////////////////////////////


limiti_torreO(U,X0,Y0,Xup,Xdown):-

  cercaO(U,X0,Y0,8,1,Xup,Xdown).


cercaO([],_,_,Up,Down,Up,Down).

cercaO([(_,X,Y)|C],XF,Y,Up,Down,Max,Min):-
  X=<Up,X>XF,
  Up1 is X-1,!,
  cercaO(C,XF,Y,Up1,Down,Max,Min).

cercaO([(_,X,Y)|C],XF,Y,Up,Down,Max,Min):-
  X>=Down,X<XF,
  Down1 is X+1,!,
  cercaO(C,XF,Y,Up,Down1,Max,Min).

cercaO([(_,_,_)|C],XF,YF,Up,Down,Max,Min):-
  !,cercaO(C,XF,YF,Up,Down,Max,Min).

%///////////////////////////////////
%//            PRESA TORRE        //
%///////////////////////////////////


presa_torre(Giocatore,Scacchiera,(X0,Y0),(X,Y),Idx,(X,Y)) :-
 pieces(Giocatore,Scacchiera,Proprio,Avversario),
 presa_torreV(Avversario,Proprio,(X0,Y0),Idx,(X,Y)).

presa_torre(Giocatore,Scacchiera,(X0,Y0),(X,Y),Idx,(X,Y)) :-
 pieces(Giocatore,Scacchiera,Proprio,Avversario),
 presa_torreO(Avversario,Proprio,(X0,Y0),Idx,(X,Y)).

presa_torreV(Avversario,Proprio,(X0,Y0),Idx,(X,Y)):-
 merge_pieces((Avversario,Proprio),U),
 limiti_torrePV(U,X0,Y0,Yup,_),
 restituisci1(Avversario,X0,Yup,_,_,X,Y,Idx).

presa_torreV(Avversario,Proprio,(X0,Y0),Idx,(X,Y)):-
 merge_pieces((Avversario,Proprio),U),
 limiti_torrePV(U,X0,Y0,_,Ydown),
 restituisci2(Avversario,X0,Ydown,_,_,X,Y,Idx).

presa_torreO(Avversario,Proprio,(X0,Y0),Idx,(X,Y)):-
 merge_pieces((Avversario,Proprio),U),
 limiti_torrePO(U,X0,Y0,Xup,_),
 restituisci1(Avversario,Xup,Y0,_,_,X,Y,Idx).

presa_torreO(Avversario,Proprio,(X0,Y0),Idx,(X,Y)):-
 merge_pieces((Avversario,Proprio),U),
 limiti_torrePO(U,X0,Y0,_,Xdown),
 restituisci2(Avversario,Xdown,Y0,_,_,X,Y,Idx).


%///////////////////////////////////////////////////////
%//      LIMITI TORRE VERTICALE           //
%//////////////////////////////////////////////////////

limiti_torrePV(U,X0,Y0,Yup,Ydown):-
  % scorro tutto i doppi array di position array
   cercaPV(U,X0,Y0,8,1,Yup,Ydown).

cercaPV([],_,_,Up,Down,Up,Down).


cercaPV([(_,X,Y)|C],X,YF,Up,Down,Max,Min):-
  Y=<Up,Y>YF,
  Up1 is Y,!,
  cercaPV(C,X,YF,Up1,Down,Max,Min).

cercaPV([(_,X,Y)|C],X,YF,Up,Down,Max,Min):-
  Y>=Down,Y<YF,
  Down1 is Y,!,
  cercaPV(C,X,YF,Up,Down1,Max,Min).

cercaPV([(_,_,_)|C],XF,YF,Up,Down,Max,Min):-
  cercaPV(C,XF,YF,Up,Down,Max,Min).


%///////////////////////////////////////////////////////
%//      LIMITI TORRE ORIZZONTALE         //
%//////////////////////////////////////////////////////


limiti_torrePO(U,X0,Y0,Xup,Xdown):-
   cercaPO(U,X0,Y0,8,1,Xup,Xdown).


cercaPO([],_,_,Up,Down,Up,Down).

cercaPO([(_,X,Y)|C],XF,Y,Up,Down,Max,Min):-
  X=<Up,X>XF,
  Up1 is X,!,
  cercaPO(C,XF,Y,Up1,Down,Max,Min).

cercaPO([(_,X,Y)|C],XF,Y,Up,Down,Max,Min):-
  X>=Down,X<XF,
  Down1 is X,!,
  cercaPO(C,XF,Y,Up,Down1,Max,Min).

cercaPO([(_,_,_)|C],XF,YF,Up,Down,Max,Min):-
  !,cercaPO(C,XF,YF,Up,Down,Max,Min).

