% scacco

:- ['../../engine/debug'].

% 4) won(+Value)
% --------------
% Ha successo se  un valore di vittoria
won(1).

% 5) is_leaf(+Position, -Value)
% -----------------------------
% funzione di valutazione
% Input: position
% Data una posizione dice se c  una vittoria del giocatore corrente e 
% nel caso ritorna il valore della funzione di valutazione, altrimenti
% fallisce
is_leaf((Giocatore,Scacchiera),1) :- 
  opponent(Giocatore,Avversario),
  scacco_matto((Avversario,Scacchiera)), !. 

/*
scaccoMatto(+Pos,+Giocatore) :- 
  scacco(+Pos,+Giocatore,_),
  avversario(+Giocatore,-Avversario),
  setof(.....,-Moves),
  controllaScacco(+Pos,+Moves,+Giocatore,+Avversario).
*/

/*
% scacco_matto(+Position)
scacco_matto(_).
*/
scacco_matto((Giocatore,Scacchiera)) :-
  scacco_re((Giocatore,Scacchiera)),
  opponent(Giocatore,Avv),
%  writef('AVV %w',[Avv]),nl,
  findall(M,move((Avv,Scacchiera),M),Moves), 
%  writef('Mosse: %w\n',[Moves]),
  Moves = [].
%  controlla_scacco(Moves,(Giocatore,Scacchiera)).
/*
controlla_scacco([],_).
controlla_scacco([M|Moves],Position) :-
  move(M,Position,NewPos),
  scacco_re(NewPos), 
  writef('M is %w',[M]),nl,nl,
  controlla_scacco(Moves,Position).
*/

scacco_re((Giocatore,Scacchiera)) :-
  pieces(Giocatore,Scacchiera,Miei,Altri),
  re(Altri,(Xr,Yr)),
  scacco(Giocatore,Scacchiera,Miei,(Xr,Yr)).

scacco(_,_,[],_) :- !, fail.
scacco(Giocatore,Scacchiera,Pezzi,PosRe) :-
  continua_controllo(Giocatore,Scacchiera,Pezzi,PosRe).
continua_controllo(Giocatore,Scacchiera,[(T,X,Y)|_],(Xr,Yr)) :-
% se presa ritorna false allora controllo anche gli altri
% else se presa ritorna true allora termino  
  allpresa(Giocatore,Scacchiera,T,(X,Y),(Xr,Yr)), !.
/*
  writeDebug((normal,nil),'il %w %w in %w,%w fa scacco al re in %w,%w',
             [T,Giocatore,X,Y,Xr,Yr]).
*/
continua_controllo(Avversario,Scacchiera,[_|C],(Xr,Yr)) :-
  scacco(Avversario,Scacchiera,C,(Xr,Yr)).
  
% 6) euristics(+Position, -Value)
% -------------------------------------------------
% funzione di valutazione
% Input: position
euristics(_,0). % no vittoria

% patta?











