% configurazione di prova per il debug

user:file_search_path(engine,'../engine').
:- [regole].
:- [engine(minimax),
    engine(alfabeta)].


prova(Alg) :-
  prova(Alg,y).

prova(Alg,RequireDetails) :-
  scacchiera(1,Scacchiera),
  matto2mosse(Alg,Scacchiera,RequireDetails,Errore,Mossa,Valore,Tempi,List),
/*
  OldPos = (bianco,Scacchiera),
  statistics(runtime,_),
  writef('Elaboro con %w...',[Alg]),
  flush_output,
  computer_move(Alg,3,OldPos,Mossa,Valore), 
  writeln('fatto'),
  statistics(runtime,[_,Tempo]),
  writef('Mossa: %w\nValore: %w\nTempo: %w\n\n',[Mossa,Valore,Tempo]),
  details(Alg,OldPos,y,Mossa,Valore,List),
*/
  writef('Codice errore: %w\nMossa: %w\nValore: %w\nTempo: %w\n',
         [Errore,Mossa,Valore,Tempi]),
  writef('Lista mosse-contromosse: %w\n',[List]).

esempio(T,Alg) :- 
  scacchiera(T,Scacchiera),
  m(Alg,3,bianco,Scacchiera,Errore,Mossa,Valore,Tempi),
  scriveSol(Errore,Mossa,Valore,Tempi).
esempio(T,v,Alg) :- 
  scacchiera(T,v,Scacchiera),
  m(Alg,2,nero,Scacchiera,Errore,Mossa,Valore,Tempi),
  scriveSol(Errore,Mossa,Valore,Tempi).
esempio(T,vv,Alg) :- 
  scacchiera(T,vv,Scacchiera),
  m(Alg,1,bianco,Scacchiera,Errore,Mossa,Valore,Tempi),
  scriveSol(Errore,Mossa,Valore,Tempi).

scacchiera(1,Scacchiera) :- Scacchiera =
  ( [ (re, 5, 5)], [ (re, 8, 4), (alfiere, 6, 8), (regina, 3, 2), (alfiere, 1, 2)]).
scacchiera(1,v,Scacchiera) :- Scacchiera =
  ( [ (re, 5, 5)], [ (re, 8, 4), (alfiere, 6, 8), (regina, 3, 2), (alfiere, 2, 1)]).
scacchiera(1,vv,Scacchiera) :- Scacchiera =
  ( [ (re, 4, 4)], [ (re, 8, 4), (alfiere, 6, 8), (regina, 3, 2), (alfiere, 2, 1)]).
scacchiera(m1m,Scacchiera) :- Scacchiera =
  (   [ (re, 5, 1)], [ (re, 1, 8), (torre, 6, 8), (alfiere, 8, 6), (regina, 3, 8), (alfiere, 1, 4)] ).
scacchiera(m1m,v,Scacchiera) :- Scacchiera =
  (   [ (re, 5, 1)], [ (re, 1, 8), (torre, 6, 8), (alfiere, 8, 6), (regina, 5, 6), (alfiere, 1, 4)] ).

m(Alg,Depth,Giocatore,Scacchiera,Errore,Mossa,Valore,Tempi) :-
  statistics(runtime,_),
  fai_move(Alg,Depth,Giocatore,Scacchiera,Mossa,Valore,Errore),
  statistics(runtime,[_,Tempi]).
fai_move(Alg,Depth,Giocatore,Scacchiera,Mossa,Valore,ok) :-
  computer_move(Alg,Depth,(Giocatore,Scacchiera),Mossa,Valore,normal), !.
fai_move(_,_,_,_,_,_,illegal).

scriveSol(Errore,Mossa,Valore,Tempi) :-
  writef('\n\nErrore: %w\nMossa: %w\nValore: %w\nTempi: %w\n\n',
         [Errore,Mossa,Valore,Tempi]).




